/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef BYTESHIFTARRAY_20060825_H_
#define BYTESHIFTARRAY_20060825_H_

#include <cstddef>
#include <stdint.h>

class ByteShiftArray {
public:
	ByteShiftArray(std::size_t size);
	ByteShiftArray(const ByteShiftArray& other);
	~ByteShiftArray();
	
public:
	ByteShiftArray &rol();
	ByteShiftArray &ror();
	
public:
	std::size_t size() const;
	
public:
	uint8_t &operator[](std::size_t i);
	const uint8_t operator[](std::size_t i) const;
	
public:
	const uint8_t *data() const;
	
public:
	void clear();
	
private:
	uint8_t *m_Data;
	std::size_t m_Size;
};

#endif

