/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "ByteShiftArray.h"
#include <cstring>

ByteShiftArray::ByteShiftArray(std::size_t size) : m_Size(size) {
	m_Data = new uint8_t[m_Size];
}

ByteShiftArray::ByteShiftArray(const ByteShiftArray& other) {
	m_Size = other.m_Size;
	m_Data = new uint8_t[m_Size];
}

ByteShiftArray::~ByteShiftArray() {
	delete [] m_Data;
}

ByteShiftArray &ByteShiftArray::rol() {

	for(std::size_t i = 0; i < (m_Size - 1); ++i) {
		m_Data[i] = m_Data[i + 1];
	}
	
	m_Data[m_Size - 1] = 0;

	return *this;
}

ByteShiftArray &ByteShiftArray::ror() {
	for(std::size_t i = m_Size - 1; i >= 1; --i) {
		m_Data[i] = m_Data[i - 1];
	}
	
	m_Data[0] = 0;
	return *this;
}

std::size_t ByteShiftArray::size() const {
	return m_Size;
}

uint8_t &ByteShiftArray::operator[](std::size_t i) {
	return m_Data[i];
}

const uint8_t ByteShiftArray::operator[](std::size_t i) const {
	return m_Data[i];
}

const uint8_t *ByteShiftArray::data() const {
	return m_Data;
}

void ByteShiftArray::clear() {
	std::memset(m_Data, 0, m_Size);
}
