/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "ByteStreamRegion.h"
#include "Debugger.h"
#include "DebuggerCoreInterface.h"

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
ByteStreamRegion::ByteStreamRegion() {

}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
ByteStreamRegion::ByteStreamRegion(const MemoryRegions::Region &r) : m_Region(r) {

}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
ByteStreamRegion::~ByteStreamRegion() {

}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
void ByteStreamRegion::clear() {
	m_Region = MemoryRegions::Region();
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
ByteStreamRegion::size_type ByteStreamRegion::size() const {
	return m_Region.size();
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
ByteStreamRegion::size_type ByteStreamRegion::max_size() const {
	return static_cast<size_type>(-1);
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
bool ByteStreamRegion::empty() const {
	return size() != 0;
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
ByteStreamRegion::value_type ByteStreamRegion::read(ByteStreamRegion::size_type i) const {
	value_type ret;
	Debugger::debuggerBase->readBytes(m_Region.start + i, &ret, sizeof(ret));
	return ret;
}

//------------------------------------------------------------------------------
// Name: 
// Desc: 
//------------------------------------------------------------------------------
void ByteStreamRegion::write(ByteStreamRegion::size_type i, const ByteStreamRegion::value_type &v) {
	Debugger::debuggerBase->writeBytes(m_Region.start + i, &v, sizeof(v));
}
