#!/usr/bin/env python2.4

'''
	libdisasm.ia32.isa : Python port of the libdisasm opcode tables
	WARNING: This file is autogenerated: do not edit!
'''
import libdisasm.isa as ISA

# sizes of various registers
REG_DWORD_SIZE = 4
REG_WORD_SIZE = 2
REG_BYTE_SIZE = 1
REG_MMX_SIZE = 8
REG_SIMD_SIZE = 16
REG_DEBUG_SIZE = 4
REG_CTRL_SIZE = 4
REG_TEST_SIZE = 4
REG_SEG_SIZE = 2
REG_FPU_SIZE = 10
REG_FLAGS_SIZE = 4
REG_FPCTRL_SIZE = 2
REG_FPSTATUS_SIZE = 2
REG_FPTAG_SIZE = 2
REG_EIP_SIZE = 4
REG_IP_SIZE = 2
REG_TASK_SIZE = 80

 
# indexes of significant registers in the register table
# NOTE: these are used in the decoding methods and are not intended
#       to be comprehensive
REG_DWORD_INDEX = 1
REG_EAX_INDEX = 1
REG_ECX_INDEX = 2
REG_EDX_INDEX = 3
REG_EBX_INDEX = 4
REG_ESP_INDEX = 5
REG_EBP_INDEX = 6
REG_ESI_INDEX = 7
REG_EDI_INDEX = 8
REG_WORD_INDEX = 9
REG_AX_INDEX = 9
REG_CX_INDEX = 10
REG_DX_INDEX = 11
REG_BX_INDEX = 12
REG_SP_INDEX = 13
REG_BP_INDEX = 14
REG_SI_INDEX = 15
REG_DI_INDEX = 16
REG_BYTE_INDEX = 17
REG_AL_INDEX = 17
REG_CL_INDEX = 18
REG_DL_INDEX = 19
REG_BL_INDEX = 20
REG_AH_INDEX = 21
REG_CH_INDEX = 22
REG_DH_INDEX = 23
REG_BH_INDEX = 24
REG_MMX_INDEX = 25
REG_SIMD_INDEX = 33
REG_DEBUG_INDEX = 41
REG_CTRL_INDEX = 49
REG_CR0_INDEX = 49
REG_CR4_INDEX = 53
REG_TEST_INDEX = 57
REG_SEG_INDEX = 65
REG_ES_INDEX = 65
REG_CS_INDEX = 66
REG_SS_INDEX = 67
REG_DS_INDEX = 68
REG_FS_INDEX = 69
REG_GS_INDEX = 70
REG_LDTR_INDEX = 71
REG_GDTR_INDEX = 72
REG_FPU_INDEX = 73
REG_ST0_INDEX = 73
REG_ST1_INDEX = 74
REG_ST2_INDEX = 75
REG_ST3_INDEX = 76
REG_ST4_INDEX = 77
REG_ST5_INDEX = 78
REG_ST6_INDEX = 79
REG_ST7_INDEX = 80
REG_FLAGS_INDEX = 81
REG_FPCTRL_INDEX = 82
REG_FPSTATUS_INDEX = 83
REG_FPTAG_INDEX = 84
REG_EIP_INDEX = 85
REG_IP_INDEX = 86
REG_IDTR_INDEX = 87
REG_MXCSG_INDEX = 88
REG_TR_INDEX = 89
REG_CSMSR_INDEX = 90
REG_ESPMSR_INDEX = 91
REG_EIPMSR_INDEX = 92

# NOTE: the MMX register mapping is fixed to the physical registers
# used by the FPU. The floating FP stack does not effect the location
# of the MMX registers, so this aliasing is not 100% accurate.

ia32_registers = (
	None,	# register ID 0 is invalid
	# REG_DWORD_INDEX 
	{ 'size':REG_DWORD_SIZE, 'type':'general, return value', 'alias_of':None, 'name':'eax' },
	{ 'size':REG_DWORD_SIZE, 'type':'general, rep counter', 'alias_of':None, 'name':'ecx' },
	{ 'size':REG_DWORD_SIZE, 'type':'general', 'alias_of':None, 'name':'edx' },
	{ 'size':REG_DWORD_SIZE, 'type':'general', 'alias_of':None, 'name':'ebx' },
	# REG_ESP_INDEX 
	{ 'size':REG_DWORD_SIZE, 'type':'general, stack pointer', 'alias_of':None, 'name':'esp' },
	{ 'size':REG_DWORD_SIZE, 'type':'general, frame pointer', 'alias_of':None, 'name':'ebp' },
	{ 'size':REG_DWORD_SIZE, 'type':'general, rep source', 'alias_of':None, 'name':'esi' },
	{ 'size':REG_DWORD_SIZE, 'type':'general, rep dest', 'alias_of':None, 'name':'edi' },
	# REG_WORD_INDEX 
	{ 'size':REG_WORD_SIZE, 'type':'general, return value', 'alias_of':REG_EAX_INDEX, 'alias_shift':0, 'name':'ax' },
	{ 'size':REG_WORD_SIZE, 'type':'general, rep counter', 'alias_of':REG_ECX_INDEX, 'alias_shift':0, 'name':'cx' },
	{ 'size':REG_WORD_SIZE, 'type':'general', 'alias_of':REG_EDX_INDEX, 'alias_shift':0, 'name':'dx' },
	{ 'size':REG_WORD_SIZE, 'type':'general', 'alias_of':REG_EBX_INDEX, 'alias_shift':0, 'name':'bx' },
	{ 'size':REG_WORD_SIZE, 'type':'general, stack pointer', 'alias_of':REG_ESP_INDEX, 'alias_shift':0, 'name':'sp' },
	{ 'size':REG_WORD_SIZE, 'type':'general, frame pointer', 'alias_of':REG_EBP_INDEX, 'alias_shift':0, 'name':'bp' },
	{ 'size':REG_WORD_SIZE, 'type':'general, rep source', 'alias_of':REG_ESI_INDEX, 'alias_shift':0, 'name':'si' },
	{ 'size':REG_WORD_SIZE, 'type':'general, rep dest', 'alias_of':REG_EDI_INDEX, 'alias_shift':0, 'name':'di' },
	# REG_BYTE_INDEX 
	{ 'size':REG_BYTE_SIZE, 'type':'general', 'alias_of':REG_EAX_INDEX, 'alias_shift':0, 'name':'al' },
	{ 'size':REG_BYTE_SIZE, 'type':'general', 'alias_of':REG_ECX_INDEX, 'alias_shift':0, 'name':'cl' },
	{ 'size':REG_BYTE_SIZE, 'type':'general', 'alias_of':REG_EDX_INDEX, 'alias_shift':0, 'name':'dl' },
	{ 'size':REG_BYTE_SIZE, 'type':'general', 'alias_of':REG_EBX_INDEX, 'alias_shift':0, 'name':'bl' },
	{ 'size':REG_BYTE_SIZE, 'type':'general', 'alias_of':REG_EAX_INDEX, 'alias_shift':8, 'name':'ah' },
	{ 'size':REG_BYTE_SIZE, 'type':'general', 'alias_of':REG_ECX_INDEX, 'alias_shift':8, 'name':'ch' },
	{ 'size':REG_BYTE_SIZE, 'type':'general', 'alias_of':REG_EDX_INDEX, 'alias_shift':8, 'name':'dh' },
	{ 'size':REG_BYTE_SIZE, 'type':'general', 'alias_of':REG_EBX_INDEX, 'alias_shift':8, 'name':'bh' },
	# REG_MMX_INDEX 
	{ 'size':REG_MMX_SIZE, 'type':'simd', 'alias_of':REG_ST0_INDEX, 'alias_shift':0, 'name':'mm0' },
	{ 'size':REG_MMX_SIZE, 'type':'simd', 'alias_of':REG_ST1_INDEX, 'alias_shift':0, 'name':'mm1' },
	{ 'size':REG_MMX_SIZE, 'type':'simd', 'alias_of':REG_ST2_INDEX, 'alias_shift':0, 'name':'mm2' },
	{ 'size':REG_MMX_SIZE, 'type':'simd', 'alias_of':REG_ST3_INDEX, 'alias_shift':0, 'name':'mm3' },
	{ 'size':REG_MMX_SIZE, 'type':'simd', 'alias_of':REG_ST4_INDEX, 'alias_shift':0, 'name':'mm4' },
	{ 'size':REG_MMX_SIZE, 'type':'simd', 'alias_of':REG_ST5_INDEX, 'alias_shift':0, 'name':'mm5' },
	{ 'size':REG_MMX_SIZE, 'type':'simd', 'alias_of':REG_ST6_INDEX, 'alias_shift':0, 'name':'mm6' },
	{ 'size':REG_MMX_SIZE, 'type':'simd', 'alias_of':REG_ST7_INDEX, 'alias_shift':0, 'name':'mm7' },
	# REG_SIMD_INDEX 
	{ 'size':REG_SIMD_SIZE, 'type':'simd', 'alias_of':None, 'name':'xmm0' },
	{ 'size':REG_SIMD_SIZE, 'type':'simd', 'alias_of':None, 'name':'xmm1' },
	{ 'size':REG_SIMD_SIZE, 'type':'simd', 'alias_of':None, 'name':'xmm2' },
	{ 'size':REG_SIMD_SIZE, 'type':'simd', 'alias_of':None, 'name':'xmm3' },
	{ 'size':REG_SIMD_SIZE, 'type':'simd', 'alias_of':None, 'name':'xmm4' },
	{ 'size':REG_SIMD_SIZE, 'type':'simd', 'alias_of':None, 'name':'xmm5' },
	{ 'size':REG_SIMD_SIZE, 'type':'simd', 'alias_of':None, 'name':'xmm6' },
	{ 'size':REG_SIMD_SIZE, 'type':'simd', 'alias_of':None, 'name':'xmm7' },
	# REG_DEBUG_INDEX 
	{ 'size':REG_DEBUG_SIZE, 'type':'system', 'alias_of':None,'name':'dr0'},
	{ 'size':REG_DEBUG_SIZE, 'type':'system', 'alias_of':None,'name':'dr1'},
	{ 'size':REG_DEBUG_SIZE, 'type':'system', 'alias_of':None,'name':'dr2'},
	{ 'size':REG_DEBUG_SIZE, 'type':'system', 'alias_of':None,'name':'dr3'},
	{ 'size':REG_DEBUG_SIZE, 'type':'system', 'alias_of':None,'name':'dr4'},
	{ 'size':REG_DEBUG_SIZE, 'type':'system', 'alias_of':None,'name':'dr5'},
	{ 'size':REG_DEBUG_SIZE, 'type':'system', 'alias_of':None,'name':'dr6'},
	{ 'size':REG_DEBUG_SIZE, 'type':'system', 'alias_of':None,'name':'dr7'},
	# REG_CTRL_INDEX 
	{ 'size':REG_CTRL_SIZE, 'type':'system', 'alias_of':None, 'name':'cr0'},
	{ 'size':REG_CTRL_SIZE, 'type':'system', 'alias_of':None, 'name':'cr1'},
	{ 'size':REG_CTRL_SIZE, 'type':'system', 'alias_of':None, 'name':'cr2'},
	{ 'size':REG_CTRL_SIZE, 'type':'system', 'alias_of':None, 'name':'cr3'},
	{ 'size':REG_CTRL_SIZE, 'type':'system', 'alias_of':None, 'name':'cr4'},
	{ 'size':REG_CTRL_SIZE, 'type':'system', 'alias_of':None, 'name':'cr5'},
	{ 'size':REG_CTRL_SIZE, 'type':'system', 'alias_of':None, 'name':'cr6'},
	{ 'size':REG_CTRL_SIZE, 'type':'system', 'alias_of':None, 'name':'cr7'},
	# REG_TEST_INDEX 
	{ 'size':REG_TEST_SIZE, 'type':'system', 'alias_of':None, 'name':'tr0'},
	{ 'size':REG_TEST_SIZE, 'type':'system', 'alias_of':None, 'name':'tr1'},
	{ 'size':REG_TEST_SIZE, 'type':'system', 'alias_of':None, 'name':'tr2'},
	{ 'size':REG_TEST_SIZE, 'type':'system', 'alias_of':None, 'name':'tr3'},
	{ 'size':REG_TEST_SIZE, 'type':'system', 'alias_of':None, 'name':'tr4'},
	{ 'size':REG_TEST_SIZE, 'type':'system', 'alias_of':None, 'name':'tr5'},
	{ 'size':REG_TEST_SIZE, 'type':'system', 'alias_of':None, 'name':'tr6'},
	{ 'size':REG_TEST_SIZE, 'type':'system', 'alias_of':None, 'name':'tr7'},
	# REG_SEG_INDEX 
	{ 'size':REG_SEG_SIZE, 'type':'segment', 'alias_of':None, 'name':'es' },
	{ 'size':REG_SEG_SIZE, 'type':'segment', 'alias_of':None, 'name':'cs' },
	{ 'size':REG_SEG_SIZE, 'type':'segment', 'alias_of':None, 'name':'ss' },
	{ 'size':REG_SEG_SIZE, 'type':'segment', 'alias_of':None, 'name':'ds' },
	{ 'size':REG_SEG_SIZE, 'type':'segment', 'alias_of':None, 'name':'fs' },
	{ 'size':REG_SEG_SIZE, 'type':'segment', 'alias_of':None, 'name':'gs' },
	# REG_LDTR_INDEX 
	{ 'size':REG_DWORD_SIZE, 'type':'system', 'alias_of':None, 'name':'ldtr' },
	# REG_GDTR_INDEX 
	{ 'size':REG_DWORD_SIZE, 'type':'system', 'alias_of':None, 'name':'gdtr' },
	# REG_FPU_INDEX 
	{ 'size':REG_FPU_SIZE, 'type':'floating point', 'alias_of':None, 'name':'st(0)' },
	{ 'size':REG_FPU_SIZE, 'type':'floating point', 'alias_of':None, 'name':'st(1)' },
	{ 'size':REG_FPU_SIZE, 'type':'floating point', 'alias_of':None, 'name':'st(2)' },
	{ 'size':REG_FPU_SIZE, 'type':'floating point', 'alias_of':None, 'name':'st(3)' },
	{ 'size':REG_FPU_SIZE, 'type':'floating point', 'alias_of':None, 'name':'st(4)' },
	{ 'size':REG_FPU_SIZE, 'type':'floating point', 'alias_of':None, 'name':'st(5)' },
	{ 'size':REG_FPU_SIZE, 'type':'floating point', 'alias_of':None, 'name':'st(6)' },
	{ 'size':REG_FPU_SIZE, 'type':'floating point', 'alias_of':None, 'name':'st(7)' },
	# REG_FLAGS_INDEX : 81 
	{ 'size':REG_FLAGS_SIZE, 'type':'condition codes', 'alias_of':None, 'name':'eflags' }, 
	# REG_FPCTRL_INDEX  : 82
	{ 'size':REG_FPCTRL_SIZE, 'type':'floating point, system', 'alias_of':None, 'name':'fpctrl' }, 
	# REG_FPSTATUS_INDEX : 83
	{ 'size':REG_FPSTATUS_SIZE, 'type':'floating point, system', 'alias_of':None, 'name':'fpstat' },
	# REG_FPTAG_INDEX : 84 
	{ 'size':REG_FPTAG_SIZE, 'type':'floating point, system', 'alias_of':None, 'name':'fptag' }, 
	# REG_EIP_INDEX : 85 
	{ 'size':REG_EIP_SIZE, 'type':'program counter', 'alias_of':None, 'name':'eip' },
	# REG_IP_INDEX : 86 
	{ 'size':REG_IP_SIZE, 'type':'program counter', 'alias_of':REG_EIP_INDEX, 'alias_shift':0, 'name':'ip' },
	# REG_IDTR_INDEX : 87 
	{ 'size':REG_DWORD_SIZE, 'type':'system', 'alias_of':None, 'name':'idtr' },
	# REG_MXCSG_INDEX : SSE Control Reg : 88 
	{ 'size':REG_DWORD_SIZE, 'type':'system, simd', 'alias_of':None, 'name':'mxcsr' },
	# REG_TR_INDEX : Task Register : 89 
	{ 'size':REG_TASK_SIZE, 'type':'system', 'alias_of':None, 'name':'tr' },
	# REG_CSMSR_INDEX : SYSENTER_CS_MSR : 90 
	{ 'size':REG_DWORD_SIZE, 'type':'system', 'alias_of':None, 'name':'cs_msr' },
	# REG_ESPMSR_INDEX : SYSENTER_ESP_MSR : 91 
	{ 'size':REG_DWORD_SIZE, 'type':'system', 'alias_of':None, 'name':'esp_msr' },
	# REG_EIPMSR_INDEX : SYSENTER_EIP_MSR : 92 
	{ 'size':REG_DWORD_SIZE, 'type':'system', 'alias_of':None, 'name':'eip_msr' }
)

def register_lookup(id):
	''' Register lookup:
	    Return register decriptor (dictionary) for ID.
	    ID is an operand value from opcode tables or modr/m decoding.
	'''
	return ia32_registers[id]

# runtime cache of register objects
ia32_register_objects = [ None ] * 92

def register_factory(id):
	if ia32_register_objects[id]:
		return ia32_register_objects[id]

	descr = ia32_registers[id]
	alias = None
	if descr['alias_of']:
		alias = register_factory(descr['alias_of'])
	reg = ISA.Register(descr, alias, id)
	ia32_register_objects[id] = reg

	return reg
# This is a list of implicit operands which are read/written by
# various x86 instructions. Note that modifications to the stack
# register are mentioned here, but that additional information on
# the effect an instruction has on the stack is contained in the
# x86_insn_t 'stack_mod' and 'stack_mod_val' fields. Use of the
# eflags register, i.e. setting, clearing, and testing flags, is
# not recorded here but rather in the flags_set and flags_tested
# fields of the x86_insn_t.

# Conventions: Register operands which are aliases of another register 
# operand (e.g. AX in one operand and AL in another) assume that the
# operands are different registers and that alias tracking will resolve
# data flow. This means that something like
#   	mov ax, al
# would have 'write only' access for AX and 'read only' access for AL,
# even though both AL and AX are read and written 

# TODO: add a datatype and operand size field

implicit_operands = (
	None,							# invalid
	# 37 : AAA : rw AL 
	# 3F : AAS : rw AL 
	( { 'access':'rw-', 'register':REG_AL_INDEX },	), 	# aaa 

	# D5 0A, D5 (ib) : AAD : rw AX 
	# D4 0A, D4 (ib) : AAM : rw AX 
	( { 'access':'rw-', 'register':REG_AX_INDEX }, ),	# aad 

	# E8, FF, 9A, FF : CALL : rw ESP, rw EIP 
	# C2, C3, CA, CB : RET  : rw ESP, rw EIP
	( { 'access':'rw-', 'register':REG_EIP_INDEX }, 
	  { 'access':'rw-', 'register':REG_ESP_INDEX } ),	# call 

	# 98 : CBW : r AL, rw AX 
	( { 'access':'rw-', 'register':REG_AX_INDEX },
	  { 'access':'r--', 'register':REG_AL_INDEX} ),	# cbw 

	# 98 : CWDE : r AX, rw EAX 
	( { 'access':'rw-', 'register':REG_EAX_INDEX },
	  { 'access':'r--', 'register':REG_AX_INDEX } ),	# cwde 

	# 0F 06 : CLTS : rw CR0 
	( { 'access':'rw-', 'register':REG_CR0_INDEX}, ),	# clts 

	# 0F B0 : CMPXCHG : rw AL 
	( { 'access':'rw-', 'register':REG_AL_INDEX }, ),	# cmpxchg 

	# 0F B1 : CMPXCHG : rw EAX 
	( { 'access':'rw-', 'register':REG_EAX_INDEX }, ),	# cmpxchg 

	# 0F C7 : CMPXCHG8B : rw EDX, rw EAX, r ECX, r EBX 
	( { 'access':'rw-', 'register':REG_EAX_INDEX }, 
	  { 'access':'rw-', 'register':REG_EDX_INDEX }, 
	  { 'access':'r--', 'register':REG_ECX_INDEX }, 
	  { 'access':'r--', 'register':REG_EBX_INDEX } ),	# cmpxchg8b 

	# 0F A2 : CPUID : rw EAX, w EBX, w ECX, w EDX 
	( { 'access':'rw-', 'register':REG_EAX_INDEX }, 
	  { 'access':'-w-', 'register':REG_ECX_INDEX }, 
	  { 'access':'-w-', 'register':REG_EDX_INDEX }, 
	  { 'access':'-w-', 'register':REG_EBX_INDEX } ),	# cpuid 

	# 99 : CWD/CWQ : rw EAX, w EDX 
	( { 'access':'rw-', 'register':REG_EAX_INDEX }, 
	  { 'access':'-w-', 'register':REG_EDX_INDEX } ),	# cwd 

	# 27 : DAA : rw AL 
	# 2F : DAS : rw AL 
	( { 'access':'rw-', 'register':REG_AL_INDEX }, ),	# daa 

	# F6 : DIV, IDIV : r AX, w AL, w AH 
	# FIXED: first was EAX not AX. TODO: verify.
	( { 'access':'r--', 'register':REG_AX_INDEX }, 
	   { 'access':'-w-', 'register':REG_AL_INDEX },
	   { 'access':'-w-', 'register':REG_AH_INDEX } ),	# div 

	# F7 : DIV, IDIV : rw EDX, rw EAX 
	( { 'access':'rw-', 'register':REG_EDX_INDEX }, 
	   { 'access':'rw-', 'register':REG_EAX_INDEX } ),	# div 

	# C8 : ENTER : rw ESP w EBP 
	( { 'access':'rw-', 'register':REG_ESP_INDEX }, 
	  { 'access':'r--', 'register':REG_EBP_INDEX } ),	# enter 

	# D9 F0 : F2XM1 : rw ST(0) 
	# D9 E1 : FABS : rw ST(0) 
	# D9 E0 : FCHS : rw ST(0) 
	# D9 FF : FCOS : rw ST(0)
	# D8, DA : FDIV : rw ST(0) 
	# D8, DA : FDIVR : rw ST(0) 
	# D9 F2 : FPTAN : rw ST(0) 
	# D9 FC : FRNDINT : rw ST(0) 
	# D9 FB : FSINCOS : rw ST(0) 
	# D9 FE : FSIN : rw ST(0) 
	# D9 FA : FSQRT : rw ST(0) 
	# D9 F4 : FXTRACT : rw ST(0) 
	( { 'access':'rw-', 'register':REG_ST0_INDEX }, ),	# f2xm1 

	# D8, DC, DE D9 : FCOM : r ST(0) 
	# DE, DA : FICOM : r ST(0) 
	# DF, D8 : FIST : r ST(0) 
	# D9 E4 : FTST : r ST(0) 
	# D9 E5 : FXAM : r ST(0) 
	( { 'access':'r--', 'register':REG_ST0_INDEX }, ),	# fcom 

	# D9 F3 : FPATAN : r ST(0), rw ST(1) 
	( { 'access':'r--', 'register':REG_ST0_INDEX }, ),	# fpatan 

	# D9 F8, D9 F5 : FPREM : rw ST(0) r ST(1) 
	# D9 FD : FSCALE : rw ST(0), r ST(1) 
	( { 'access':'rw-', 'register':REG_ST0_INDEX }, 	
	  { 'access':'r--', 'register':REG_ST1_INDEX } ),	# fprem 

	# DE C1 : FADDP : r ST(0), rw ST(1) 
	# DE E9 : FSUBP : r ST(0), rw ST(1) 
	# D9 F1 : FYL2X : r ST(0), rw ST(1) 
	# D9 F9 : FYL2XP1 : r ST(0), rw ST(1) 
	( { 'access':'r--', 'register':REG_ST0_INDEX },
	  { 'access':'rw-', 'register':REG_ST1_INDEX } ),	# faddp 

	# DA E9 : FUCOMPP : r ST(0), r ST(1) 
	( { 'access':'r--', 'register':REG_ST0_INDEX },
	  { 'access':'r--', 'register':REG_ST1_INDEX } ),	# fucompp 

	# F6 : IMUL : r AL, w AX 
	# F6 : MUL : r AL, w AX 
	( { 'access':'r--', 'register':REG_AL_INDEX },
	  { 'access':'-w-', 'register':REG_AX_INDEX }	 ),	# imul 

	# F7 : IMUL : rw EAX, w EDX 
	# F7 : MUL : rw EAX, w EDX 
	( { 'access':'rw-', 'register':REG_EAX_INDEX },
	  { 'access':'-w-', 'register':REG_EDX_INDEX } ),	# imul 

	# 9F : LAHF : r EFLAGS, w AH 
	( { 'access':'r--', 'register':REG_FLAGS_INDEX },
	  { 'access':'-w-', 'register':REG_AH_INDEX } ),	# lahf 

	# 0F AE : LDMXCSR : w MXCSR SSE Control Status Reg 
	( { 'access':'-w-', 'register':REG_MXCSG_INDEX }, ),	# ldmxcsr 

	# C9 : LEAVE :  rw ESP, w EBP 
	( { 'access':'rw-', 'register':REG_ESP_INDEX },
	  { 'access':'-w-', 'register':REG_EBP_INDEX } ),	# leave 

	# 0F 01 : LGDT : w GDTR 
	( { 'access':'-w-', 'register':REG_GDTR_INDEX }, ),	# lgdt 

	# 0F 01 : LIDT : w IDTR 
	( { 'access':'-w-', 'register':REG_IDTR_INDEX }, ),	# lidt 

	# 0F 00 : LLDT : w LDTR 
	( { 'access':'-w-', 'register':REG_LDTR_INDEX }, ),	# lldt 

	# 0F 01 : LMSW : w CR0 
	( { 'access':'-w-', 'register':REG_CR0_INDEX }, ),	# lmsw 

	# E0, E1, E2 : LOOP : rw ECX 
	# E3 : JCXZ : rw ECX
	( { 'access':'rw-', 'register':REG_ECX_INDEX }, ),# loop 

	# 0F 00 : LTR : w Task Register 
	( { 'access':'-w-', 'register':REG_TR_INDEX }, ),	# ltr 

	# 8F, 58, 1F, 07, 17, 0F A1, 0F A9 : POP : rw ESP 
	# FF, 50, 6A, 68, 0E, 16, 1E, 06, 0F A0, 0F A8 : PUSH : rw ESP 
	( { 'access':'rw-', 'register':REG_ESP_INDEX }, ),	# pop , push

	# 61 : POPAD : rw esp, w edi esi ebp ebx edx ecx eax 
	( { 'access':'rw-', 'register':REG_ESP_INDEX },
	  { 'access':'-w-', 'register':REG_EDI_INDEX },
	  { 'access':'-w-', 'register':REG_ESI_INDEX },
	  { 'access':'-w-', 'register':REG_EBP_INDEX },
	  { 'access':'-w-', 'register':REG_EBX_INDEX },
	  { 'access':'-w-', 'register':REG_EDX_INDEX },
	  { 'access':'-w-', 'register':REG_ECX_INDEX },
	  { 'access':'-w-', 'register':REG_EAX_INDEX } ),	# popad 

	# 9D : POPFD : rw esp, w eflags 
	( { 'access':'rw-', 'register':REG_ESP_INDEX },
	  { 'access':'-w-', 'register':REG_FLAGS_INDEX } ),	# popfd 

	# 60 : PUSHAD : rw esp, r eax ecx edx ebx esp ebp esi edi 
	( { 'access':'rw-', 'register':REG_ESP_INDEX },
	  { 'access':'r--', 'register':REG_EAX_INDEX },
	  { 'access':'r--', 'register':REG_ECX_INDEX },
	  { 'access':'r--', 'register':REG_EDX_INDEX },
	  { 'access':'r--', 'register':REG_EBX_INDEX },
	  { 'access':'r--', 'register':REG_EBP_INDEX },
	  { 'access':'r--', 'register':REG_ESI_INDEX },
	  { 'access':'r--', 'register':REG_EDI_INDEX } ),	# pushad 

	# 9C : PUSHFD : rw esp, r eflags 
	( { 'access':'rw-', 'register':REG_ESP_INDEX },
	  { 'access':'r--', 'register':REG_FLAGS_INDEX } ),	# pushfd 

	# 0F 32 : RDMSR : r ECX, w EDX, w EAX 
	( { 'access':'r--', 'register':REG_ECX_INDEX },
	  { 'access':'-w-', 'register':REG_EDX_INDEX },
	  { 'access':'-w-', 'register':REG_EAX_INDEX } ),	# rdmsr 

	# 0F 33 : RDPMC : r ECX, w EDX, w EAX 
	( { 'access':'r--', 'register':REG_ECX_INDEX },
	  { 'access':'-w-', 'register':REG_EDX_INDEX },
	  { 'access':'-w-', 'register':REG_EAX_INDEX } ),	# rdpmc 

	# 0F 31 : RDTSC : rw EDX, rw EAX 
	( { 'access':'rw-', 'register':REG_EDX_INDEX },
	  { 'access':'rw-', 'register':REG_EAX_INDEX } ),	# rdtsc 

	# F3, F2 ... : REP : rw ECX 
	( { 'access':'rw-', 'register':REG_ECX_INDEX }, ),	# rep 

	# 0F AA : RSM : r CR4, r CR0 
	( { 'access':'r--', 'register':REG_CR4_INDEX }, 
	  { 'access':'r--', 'register':REG_CR0_INDEX } ),	# rsm 

	# 9E : SAHF : r ah, rw eflags (set SF ZF AF PF CF) 
	( { 'access':'r--', 'register':REG_AH_INDEX }, ),	# sahf 

	# TODO: 0F : SGDT : r gdtr 
	( { 'access':'r--', 'register':REG_EAX_INDEX }, ),	# sgdt 

	# TODO: 0F : SIDT : r idtr 
	( { 'access':'r--', 'register':REG_EAX_INDEX }, ),	# sidt 

	# TODO: 0F : SLDT : r ldtr 
	( { 'access':'r--', 'register':REG_EAX_INDEX }, ),	# sldt 

	# TODO: 0F : SMSW : r CR0 
	( { 'access':'r--', 'register':REG_EAX_INDEX }, ),	# smsw 

	# TODO: 0F AE : STMXCSR : r MXCSR 
	( { 'access':'r--', 'register':REG_EAX_INDEX }, ),	# stmxcsr 

	# TODO: 0F 00 : STR : r TR (task register) 
	( { 'access':'r--', 'register':REG_EAX_INDEX }, ),	# str 

	# TODO: 0F 34 : SYSENTER : w cs, w eip, w ss, w esp, r CR0, w eflags
	#         r sysenter_cs_msr, sysenter_esp_msr, sysenter_eip_msr 
	( { 'access':'r--', 'register':REG_EAX_INDEX }, ),	# sysenter 

	# TODO: 0F 35 : SYSEXIT : r edx, r ecx, w cs, w eip, w ss, w esp
	#      	   r sysenter_cs_msr 
	( { 'access':'r--', 'register':REG_EAX_INDEX }, ),	# sysexit 

	# TODO: 0F 30 : WRMST : r edx, r eax, r ecx 
	( { 'access':'r--', 'register':REG_EAX_INDEX }, ),	# wrmsr 

	# TODO: D7 : XLAT : rw al r ebx (ptr) 
	( { 'access':'r--', 'register':REG_EAX_INDEX }, ),	# xlat 
 
	# TODO:  monitor 0f 01 c8 eax r ecx OP_R edx OP_R
	( { 'access':'r--', 'register':REG_EAX_INDEX }, ),	# monitor 

	# TODO: mwait 0f 01 c9 eax r ecx OP_R
	( { 'access':'r--', 'register':REG_EAX_INDEX }, )	# mwait 
)

def implicit_lookup(id):
	''' Implicit operand lookup:
	    Return implicit operand list (tuple of dicts) for ID.
	    ID from the 'implicit' field of the opcode table entry for insn.
	'''
	return implicit_operands[id]
#______________________________________________________________
# Opcode tables: 
# TABLE ia32_tbl_Main ___________________________
ia32_tbl_Main = (

{ 'byte':0, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'add', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'add', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'add', 'dest':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'add', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'add', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'add', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':0,'addr_method':'RS', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':0,'addr_method':'RS', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'or', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'or', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'or', 'dest':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'or', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'or', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'or', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':1,'addr_method':'RS', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':4, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'adc', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':17, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'adc', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':18, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'adc', 'dest':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':19, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'adc', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':20, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'adc', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':21, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'adc', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':22, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':2,'addr_method':'RS', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':2,'addr_method':'RS', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sbb', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':25, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sbb', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':26, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sbb', 'dest':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':27, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sbb', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':28, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sbb', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':29, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sbb', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':30, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':3,'addr_method':'RS', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':3,'addr_method':'RS', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':32, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'and', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':33, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'and', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':34, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'and', 'dest':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':35, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'and', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':36, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'and', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':37, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'and', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':38, 'table':0, 'info':{'type':'prefix', 'group':'other', 'prefix':True, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general', 'prefix_name':'es', 'prefix_group':2}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':39, 'table':0, 'info':{'type':'bcdconv', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'daa', 'dest':None, 'src':None, 'imm':None, 'implicit':12, 'eflags':{'set':'sign zero carry parity', 'test':'carry'} },

{ 'byte':40, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sub', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':41, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sub', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':42, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sub', 'dest':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':43, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sub', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':44, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sub', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':45, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sub', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':46, 'table':0, 'info':{'type':'prefix', 'group':'other', 'prefix':True, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general', 'prefix_name':'nottaken', 'prefix_group':2}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':47, 'table':0, 'info':{'type':'bcdconv', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'das', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'sign zero carry parity', 'test':'carry'} },

{ 'byte':48, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xor', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':49, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xor', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':50, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xor', 'dest':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':51, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xor', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':52, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xor', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':53, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xor', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':54, 'table':0, 'info':{'type':'prefix', 'group':'other', 'prefix':True, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general', 'prefix_name':'ss', 'prefix_group':2}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':55, 'table':0, 'info':{'type':'bcdconv', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'aaa', 'dest':None, 'src':None, 'imm':None, 'implicit':1, 'eflags':{'set':'carry', 'test':''} },

{ 'byte':56, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmp', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':57, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmp', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':58, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmp', 'dest':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':59, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmp', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':60, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmp', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':61, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmp', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':62, 'table':0, 'info':{'type':'prefix', 'group':'other', 'prefix':True, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general', 'prefix_name':'taken', 'prefix_group':2}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':63, 'table':0, 'info':{'type':'bcdconv', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'aas', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'carry', 'test':''} },

{ 'byte':64, 'table':0, 'info':{'type':'inc', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'inc', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':65, 'table':0, 'info':{'type':'inc', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'inc', 'dest':{'value':1,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':66, 'table':0, 'info':{'type':'inc', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'inc', 'dest':{'value':2,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':67, 'table':0, 'info':{'type':'inc', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'inc', 'dest':{'value':3,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':68, 'table':0, 'info':{'type':'inc', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'inc', 'dest':{'value':4,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':69, 'table':0, 'info':{'type':'inc', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'inc', 'dest':{'value':5,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':70, 'table':0, 'info':{'type':'inc', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'inc', 'dest':{'value':6,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':71, 'table':0, 'info':{'type':'inc', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'inc', 'dest':{'value':7,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':72, 'table':0, 'info':{'type':'dec', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'dec', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':73, 'table':0, 'info':{'type':'dec', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'dec', 'dest':{'value':1,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':74, 'table':0, 'info':{'type':'dec', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'dec', 'dest':{'value':2,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':75, 'table':0, 'info':{'type':'dec', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'dec', 'dest':{'value':3,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':76, 'table':0, 'info':{'type':'dec', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'dec', 'dest':{'value':4,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':77, 'table':0, 'info':{'type':'dec', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'dec', 'dest':{'value':5,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':78, 'table':0, 'info':{'type':'dec', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'dec', 'dest':{'value':6,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':79, 'table':0, 'info':{'type':'dec', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'dec', 'dest':{'value':7,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':80, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':81, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':1,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':82, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':2,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':83, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':3,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':84, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':4,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':85, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':5,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':86, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':6,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':87, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':7,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':88, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':89, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':1,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':90, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':2,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':91, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':3,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':92, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':4,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':93, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':5,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':94, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':6,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':95, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':7,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':96, 'table':0, 'info':{'type':'pushregs', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pushad', 'dest':None, 'src':None, 'imm':None, 'implicit':36, 'eflags':{'set':'', 'test':''} },

{ 'byte':97, 'table':0, 'info':{'type':'popregs', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'popad', 'dest':None, 'src':None, 'imm':None, 'implicit':34, 'eflags':{'set':'', 'test':''} },

{ 'byte':98, 'table':0, 'info':{'type':'bounds', 'group':'traps', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'bound', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'M', 'datatype':'a', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':99, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'arpl', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'G', 'datatype':'w', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero', 'test':''} },

{ 'byte':100, 'table':0, 'info':{'type':'prefix', 'group':'other', 'prefix':True, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general', 'prefix_name':'fs', 'prefix_group':2}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':101, 'table':0, 'info':{'type':'prefix', 'group':'other', 'prefix':True, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general', 'prefix_name':'gs', 'prefix_group':2}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':102, 'table':1, 'info':{'type':'prefix', 'group':'other', 'prefix':True, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general', 'prefix_name':'op_size', 'prefix_group':3}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':103, 'table':0, 'info':{'type':'prefix', 'group':'other', 'prefix':True, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general', 'prefix_name':'addr_size', 'prefix_group':4}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':104, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':105, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'imul', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'oflow carry', 'test':''} },

{ 'byte':106, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':107, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'imul', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'oflow carry', 'test':''} },

{ 'byte':108, 'table':0, 'info':{'type':'in', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'insb', 'dest':{'value':0,'addr_method':'Y', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':109, 'table':0, 'info':{'type':'in', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'insd', 'dest':{'value':0,'addr_method':'Y', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':110, 'table':0, 'info':{'type':'out', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'outsb', 'dest':{'value':2,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'X', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':111, 'table':0, 'info':{'type':'out', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'outsb', 'dest':{'value':2,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'X', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':112, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jo', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'oflow'} },

{ 'byte':113, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jno', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'noflow'} },

{ 'byte':114, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jc', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry'} },

{ 'byte':115, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jnc', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry'} },

{ 'byte':116, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jz', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':117, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jnz', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':118, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jbe', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry or zero'} },

{ 'byte':119, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'ja', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry nzero'} },

{ 'byte':120, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'js', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'sign'} },

{ 'byte':121, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jns', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nsign'} },

{ 'byte':122, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jpe', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'parity'} },

{ 'byte':123, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jpo', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nparity'} },

{ 'byte':124, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jl', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'sfneof'} },

{ 'byte':125, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jge', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'sfeqof'} },

{ 'byte':126, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jle', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero or sfneof'} },

{ 'byte':127, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jg', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero sfeqof'} },

{ 'byte':128, 'table':26, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'---'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'---'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':129, 'table':27, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'---'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'---'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':130, 'table':28, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'---'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'---'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':131, 'table':29, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'---'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'---'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':132, 'table':0, 'info':{'type':'test', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'test', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':133, 'table':0, 'info':{'type':'test', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'test', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':134, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xchg', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':135, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xchg', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':136, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':137, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':138, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':139, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':140, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'S', 'datatype':'w', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':141, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lea', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'M', 'datatype':'m', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':142, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'S', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':143, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':144, 'table':0, 'info':{'type':'nop', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'nop', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':145, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xchg', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':146, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xchg', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':2,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':147, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xchg', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':3,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':148, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xchg', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':4,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':149, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xchg', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':5,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':150, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xchg', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':6,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':151, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xchg', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':7,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':152, 'table':0, 'info':{'type':'szconv', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cwde', 'dest':None, 'src':None, 'imm':None, 'implicit':5, 'eflags':{'set':'', 'test':''} },

{ 'byte':153, 'table':0, 'info':{'type':'szconv', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cdq', 'dest':None, 'src':None, 'imm':None, 'implicit':11, 'eflags':{'set':'', 'test':''} },

{ 'byte':154, 'table':0, 'info':{'type':'call', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'callf', 'dest':{'value':0,'addr_method':'A', 'datatype':'p', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':155, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'wait', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':156, 'table':0, 'info':{'type':'pushflags', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pushfd', 'dest':None, 'src':None, 'imm':None, 'implicit':37, 'eflags':{'set':'', 'test':''} },

{ 'byte':157, 'table':0, 'info':{'type':'popflags', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'popfd', 'dest':None, 'src':None, 'imm':None, 'implicit':35, 'eflags':{'set':'', 'test':''} },

{ 'byte':158, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sahf', 'dest':None, 'src':None, 'imm':None, 'implicit':43, 'eflags':{'set':'sign zero parity carry', 'test':''} },

{ 'byte':159, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lahf', 'dest':None, 'src':None, 'imm':None, 'implicit':24, 'eflags':{'set':'', 'test':''} },

{ 'byte':160, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'O', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':161, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'O', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':162, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'O', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':163, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'O', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':164, 'table':0, 'info':{'type':'strmov', 'group':'array', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'movsb', 'dest':{'value':0,'addr_method':'Y', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'X', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':165, 'table':0, 'info':{'type':'strmov', 'group':'array', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'movsd', 'dest':{'value':0,'addr_method':'Y', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'X', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':166, 'table':0, 'info':{'type':'strcmp', 'group':'array', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmpsb', 'dest':{'value':0,'addr_method':'Y', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'X', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':167, 'table':0, 'info':{'type':'strcmp', 'group':'array', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmpsd', 'dest':{'value':0,'addr_method':'X', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'Y', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':168, 'table':0, 'info':{'type':'test', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'test', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':169, 'table':0, 'info':{'type':'test', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'test', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':170, 'table':0, 'info':{'type':'strstor', 'group':'array', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'stosb', 'dest':{'value':0,'addr_method':'Y', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':171, 'table':0, 'info':{'type':'strstor', 'group':'array', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'stosd', 'dest':{'value':0,'addr_method':'Y', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':172, 'table':0, 'info':{'type':'strload', 'group':'array', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lodsb', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'X', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':173, 'table':0, 'info':{'type':'strload', 'group':'array', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lodsd', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'X', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':174, 'table':0, 'info':{'type':'strcmp', 'group':'array', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'scasb', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'Y', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':175, 'table':0, 'info':{'type':'strcmp', 'group':'array', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'scasd', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'Y', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':176, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':177, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':178, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':2,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':179, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':3,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':180, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':4,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':181, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':5,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':182, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':6,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':183, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':7,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':184, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':185, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':1,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':186, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':2,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':187, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':3,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':188, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':4,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':189, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':5,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':190, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':6,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':191, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':7,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':192, 'table':30, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'---'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'---'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':193, 'table':31, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'---'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'---'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':194, 'table':0, 'info':{'type':'ret', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'ret', 'dest':{'value':0,'addr_method':'I', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':3, 'eflags':{'set':'', 'test':''} },

{ 'byte':195, 'table':0, 'info':{'type':'ret', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'ret', 'dest':None, 'src':None, 'imm':None, 'implicit':3, 'eflags':{'set':'', 'test':''} },

{ 'byte':196, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'les', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'M', 'datatype':'p', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':197, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lds', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'M', 'datatype':'p', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':198, 'table':24, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':199, 'table':25, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':200, 'table':0, 'info':{'type':'enter', 'group':'stacK', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'enter', 'dest':{'value':0,'addr_method':'I', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':15, 'eflags':{'set':'', 'test':''} },

{ 'byte':201, 'table':0, 'info':{'type':'leave', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'leave', 'dest':None, 'src':None, 'imm':None, 'implicit':26, 'eflags':{'set':'', 'test':''} },

{ 'byte':202, 'table':0, 'info':{'type':'ret', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'retf', 'dest':{'value':0,'addr_method':'I', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':3, 'eflags':{'set':'', 'test':''} },

{ 'byte':203, 'table':0, 'info':{'type':'ret', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'retf', 'dest':None, 'src':None, 'imm':None, 'implicit':3, 'eflags':{'set':'', 'test':''} },

{ 'byte':204, 'table':0, 'info':{'type':'debug', 'group':'traps', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'int3', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':205, 'table':0, 'info':{'type':'trap', 'group':'traps', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'int', 'dest':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':206, 'table':0, 'info':{'type':'oflow', 'group':'traps', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'into', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'oflow'} },

{ 'byte':207, 'table':0, 'info':{'type':'tret', 'group':'traps', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'iret', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity dir', 'test':''} },

{ 'byte':208, 'table':32, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'---'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':209, 'table':33, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'---'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':210, 'table':34, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'---'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':211, 'table':35, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'---'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':212, 'table':0, 'info':{'type':'bcdconv', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'aam', 'dest':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'sign zero parity', 'test':''} },

{ 'byte':213, 'table':0, 'info':{'type':'bcdconv', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'aad', 'dest':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':2, 'eflags':{'set':'sign zero parity', 'test':''} },

{ 'byte':214, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':215, 'table':0, 'info':{'type':'xlat', 'group':'array', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xlat', 'dest':None, 'src':None, 'imm':None, 'implicit':53, 'eflags':{'set':'', 'test':''} },

{ 'byte':216, 'table':40, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':217, 'table':42, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':218, 'table':44, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':219, 'table':46, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':220, 'table':48, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':221, 'table':50, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':222, 'table':52, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':223, 'table':54, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':224, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'loopnz', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':31, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':225, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'loopz', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':31, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':226, 'table':0, 'info':{'type':'branch', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'loop', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':31, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jcxz', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':31, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'in', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'in', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'in', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'in', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'out', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'out', 'dest':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'out', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'out', 'dest':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'call', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'call', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':3, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'branch', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jmp', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'branch', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jmp', 'dest':{'value':0,'addr_method':'A', 'datatype':'p', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'branch', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jmp', 'dest':{'value':0,'addr_method':'J', 'datatype':'b', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'in', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'in', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RR', 'datatype':'w', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'in', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'in', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RR', 'datatype':'w', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'out', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'out', 'dest':{'value':2,'addr_method':'RR', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'out', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'out', 'dest':{'value':2,'addr_method':'RR', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'prefix', 'group':'other', 'prefix':True, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general', 'prefix_name':'lock', 'prefix_group':1}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':242, 'table':2, 'info':{'type':'prefix', 'group':'other', 'prefix':True, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general', 'prefix_name':'repnz', 'prefix_group':1}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':243, 'table':3, 'info':{'type':'prefix', 'group':'other', 'prefix':True, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general', 'prefix_name':'repz', 'prefix_group':1}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'halt', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'hlt', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'togcf', 'group':'flag', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmc', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'carry', 'test':''} },

{ 'byte':246, 'table':36, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'---'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':247, 'table':37, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'---'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'clearcf', 'group':'flag', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'clc', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'ncarry', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'setcf', 'group':'flag', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'stc', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'carry', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cli', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sti', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'cleardf', 'group':'flag', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cld', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'ndir', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'setdf', 'group':'flag', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'std', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'dir', 'test':''} },

{ 'byte':254, 'table':38, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':39, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} }
)


# TABLE ia32_tbl_66 ___________________________
ia32_tbl_66 = (

{ 'byte':15, 'table':5, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_F2 ___________________________
ia32_tbl_F2 = (

{ 'byte':15, 'table':6, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_F3 ___________________________
ia32_tbl_F3 = (

{ 'byte':15, 'table':7, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':32, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':33, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':34, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':35, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':36, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':37, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':38, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':39, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':40, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':41, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':42, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':43, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':44, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':45, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':46, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':47, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':48, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':49, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':50, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':51, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':52, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':53, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':54, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':55, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':56, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':57, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':58, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':59, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':60, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':61, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':62, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':63, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':64, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':65, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':66, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':67, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':68, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':69, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':70, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':71, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':72, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':73, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':74, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':75, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':76, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':77, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':78, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':79, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':80, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':81, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':82, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':83, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':84, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':85, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':86, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':87, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':88, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':89, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':90, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':91, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':92, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':93, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':94, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':95, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':96, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':97, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':98, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':99, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':100, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':101, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':102, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':103, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':104, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':105, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':106, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':107, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':108, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':109, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':110, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':111, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':112, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':113, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':114, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':115, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':116, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':117, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':118, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':119, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':120, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':121, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':122, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':123, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':124, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':125, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':126, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':127, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':128, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':129, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':130, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':131, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':132, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':133, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':134, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':135, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':136, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':137, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':138, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':139, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':140, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':141, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':142, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':143, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':144, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pause', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0F ___________________________
ia32_tbl_0F = (

{ 'byte':0, 'table':8, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':9, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lar', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lsl', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'clts', 'dest':None, 'src':None, 'imm':None, 'implicit':6, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'invd', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'wbinvd', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'ud2', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'prefetchw', 'dest':{'value':0,'addr_method':'M', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'femms', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':56, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':True, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movups', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movups', 'dest':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':11, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movlps', 'dest':{'value':0,'addr_method':'V', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'unpcklps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'unpckhps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':12, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movhps', 'dest':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'V', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':13, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':32, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'R', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'C', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':33, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'R', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'D', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':34, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'C', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'R', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':35, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'D', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'R', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':36, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'R', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'T', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':37, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':38, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'T', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'R', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':39, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':40, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movaps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':41, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movaps', 'dest':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':42, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'cvtpi2ps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':43, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movntps', 'dest':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':44, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'cvttps2pi', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':45, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'cvtps2pi', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':46, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'ucomiss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':47, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'comiss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'-w-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':48, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'general'}, 'mnemonic':'wrmsr', 'dest':None, 'src':None, 'imm':None, 'implicit':52, 'eflags':{'set':'', 'test':''} },

{ 'byte':49, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'general'}, 'mnemonic':'rdtsc', 'dest':None, 'src':None, 'imm':None, 'implicit':40, 'eflags':{'set':'', 'test':''} },

{ 'byte':50, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'general'}, 'mnemonic':'rdmsr', 'dest':None, 'src':None, 'imm':None, 'implicit':38, 'eflags':{'set':'', 'test':''} },

{ 'byte':51, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'rdpmc', 'dest':None, 'src':None, 'imm':None, 'implicit':39, 'eflags':{'set':'', 'test':''} },

{ 'byte':52, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'sysenter', 'dest':None, 'src':None, 'imm':None, 'implicit':50, 'eflags':{'set':'', 'test':''} },

{ 'byte':53, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'sysexit', 'dest':None, 'src':None, 'imm':None, 'implicit':51, 'eflags':{'set':'', 'test':''} },

{ 'byte':54, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':55, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':56, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':57, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':58, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':59, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':60, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':61, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':62, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':63, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':64, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovo', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'oflow'} },

{ 'byte':65, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovno', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'noflow'} },

{ 'byte':66, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovc', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry'} },

{ 'byte':67, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovnc', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry'} },

{ 'byte':68, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovz', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':69, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovnz', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':70, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovbe', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry or zero'} },

{ 'byte':71, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmova', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero ncarry'} },

{ 'byte':72, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovs', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'sign'} },

{ 'byte':73, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovns', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nsign'} },

{ 'byte':74, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovp', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'parity'} },

{ 'byte':75, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovnp', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nparity'} },

{ 'byte':76, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovl', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'sfneof'} },

{ 'byte':77, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovge', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'sfeqof'} },

{ 'byte':78, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovle', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero or sfneof'} },

{ 'byte':79, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'cmovg', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero sfeqof'} },

{ 'byte':80, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movmskps', 'dest':{'value':0,'addr_method':'G', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':81, 'table':0, 'info':{'type':'unknown', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'sqrtps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':82, 'table':0, 'info':{'type':'unknown', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'rsqrtps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':83, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'rcpps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':84, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'andps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':85, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'andnps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':86, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'orps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':87, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'xorps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':88, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'addps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':89, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'mulps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':90, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtps2pd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'---'}, 'src':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'---'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':91, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtdq2ps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':92, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'subps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':93, 'table':0, 'info':{'type':'unknown', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'minps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':94, 'table':0, 'info':{'type':'div', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'divps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':95, 'table':0, 'info':{'type':'unknown', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'maxps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':96, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'punpcklbw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':97, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'punpcklwd', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':98, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'punpckldq', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':99, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'packsswb', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':100, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pcmpgtb', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':101, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pcmpgtw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':102, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pcmpgtd', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':103, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'packuswb', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':104, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'punpckhbw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':105, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'punpckhwd', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':106, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'punpckhdq', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':107, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'packssdw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':108, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':109, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':110, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'movd', 'dest':{'value':0,'addr_method':'P', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':111, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'movq', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':112, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'pshufw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':113, 'table':14, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':114, 'table':16, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':115, 'table':18, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':116, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pcmpeqb', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':117, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pcmpeqw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':118, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pcmpeqd', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':119, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'emms', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':120, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':121, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':122, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':123, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':124, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':125, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':126, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'movd', 'dest':{'value':0,'addr_method':'E', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'P', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':127, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'movq', 'dest':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':128, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jo', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'oflow'} },

{ 'byte':129, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jno', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'noflow'} },

{ 'byte':130, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jc', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry'} },

{ 'byte':131, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jnc', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry'} },

{ 'byte':132, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jz', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':133, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jnz', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':134, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jbe', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry or zero'} },

{ 'byte':135, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'ja', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry nzero'} },

{ 'byte':136, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'js', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'sign'} },

{ 'byte':137, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jns', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nsign'} },

{ 'byte':138, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jpe', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'parity'} },

{ 'byte':139, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jpo', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nparity'} },

{ 'byte':140, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jl', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'sfneof'} },

{ 'byte':141, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jge', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'sfeqof'} },

{ 'byte':142, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jle', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero or sfneof'} },

{ 'byte':143, 'table':0, 'info':{'type':'branchcc', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jg', 'dest':{'value':0,'addr_method':'J', 'datatype':'v', 'signed':True, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero sfeqof'} },

{ 'byte':144, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'seto', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'oflow'} },

{ 'byte':145, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setno', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'oflow'} },

{ 'byte':146, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setc', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry'} },

{ 'byte':147, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setnc', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry'} },

{ 'byte':148, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setz', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':149, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setnz', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':150, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setbe', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry or zero'} },

{ 'byte':151, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'seta', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry nzero'} },

{ 'byte':152, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sets', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'sign'} },

{ 'byte':153, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setns', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nsign'} },

{ 'byte':154, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setpe', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'parity'} },

{ 'byte':155, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setpo', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nparity'} },

{ 'byte':156, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setl', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'sfneof'} },

{ 'byte':157, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setge', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'sfeqof'} },

{ 'byte':158, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setle', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero or sfneof'} },

{ 'byte':159, 'table':0, 'info':{'type':'movcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'setg', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero sfeqof'} },

{ 'byte':160, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':4,'addr_method':'RS', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':161, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':4,'addr_method':'RS', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':162, 'table':0, 'info':{'type':'cpuid', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'general'}, 'mnemonic':'cpuid', 'dest':None, 'src':None, 'imm':None, 'implicit':10, 'eflags':{'set':'', 'test':''} },

{ 'byte':163, 'table':0, 'info':{'type':'bittest', 'group':'bit', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'bt', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry', 'test':''} },

{ 'byte':164, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shld', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'sign zero parity carry', 'test':''} },

{ 'byte':165, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shld', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'sign zero parity carry', 'test':''} },

{ 'byte':166, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':167, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':168, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':5,'addr_method':'RS', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':169, 'table':0, 'info':{'type':'pop', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'pop', 'dest':{'value':5,'addr_method':'RS', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },

{ 'byte':170, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rsm', 'dest':None, 'src':None, 'imm':None, 'implicit':42, 'eflags':{'set':'carry zero overflow sign parity dir', 'test':''} },

{ 'byte':171, 'table':0, 'info':{'type':'bittest', 'group':'bit', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'bts', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry', 'test':''} },

{ 'byte':172, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shrd', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'sign zero parity carry', 'test':''} },

{ 'byte':173, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shrd', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'sign zero parity carry', 'test':''} },

{ 'byte':174, 'table':20, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':175, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'imul', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow carry', 'test':''} },

{ 'byte':176, 'table':0, 'info':{'type':'xchgcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'cmpxchg', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'imm':None, 'implicit':8, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':177, 'table':0, 'info':{'type':'xchgcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'cmpxchg', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'imm':None, 'implicit':7, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':178, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lss', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'M', 'datatype':'p', 'signed':False, 'access':'-w-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':179, 'table':0, 'info':{'type':'bittest', 'group':'bit', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'btr', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry', 'test':''} },

{ 'byte':180, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lfs', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'M', 'datatype':'p', 'signed':False, 'access':'-w-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':181, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lgs', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'M', 'datatype':'p', 'signed':False, 'access':'-w-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':182, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'movzx', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':183, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'movzx', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':184, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':185, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'ud1', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':186, 'table':21, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':187, 'table':0, 'info':{'type':'bittest', 'group':'bit', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'btc', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry', 'test':''} },

{ 'byte':188, 'table':0, 'info':{'type':'bittest', 'group':'bit', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'bsf', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero', 'test':''} },

{ 'byte':189, 'table':0, 'info':{'type':'bittest', 'group':'bit', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'bsr', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero', 'test':''} },

{ 'byte':190, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'movsx', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':191, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'movsx', 'dest':{'value':0,'addr_method':'G', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':192, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'xadd', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':193, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'xadd', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':194, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cmpps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':195, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movnti', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'G', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':196, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'pinsrw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':197, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'pextrw', 'dest':{'value':0,'addr_method':'G', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':198, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'shufps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':199, 'table':0, 'info':{'type':'xchgcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'general'}, 'mnemonic':'cmpxchg8b', 'dest':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':9, 'eflags':{'set':'', 'test':''} },

{ 'byte':200, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'bswap', 'dest':{'value':0,'addr_method':'RR', 'datatype':'d', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':201, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'bswap', 'dest':{'value':1,'addr_method':'RR', 'datatype':'d', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':202, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'bswap', 'dest':{'value':2,'addr_method':'RR', 'datatype':'d', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':203, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'bswap', 'dest':{'value':3,'addr_method':'RR', 'datatype':'d', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':204, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'bswap', 'dest':{'value':4,'addr_method':'RR', 'datatype':'d', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':205, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'bswap', 'dest':{'value':5,'addr_method':'RR', 'datatype':'d', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':206, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'bswap', 'dest':{'value':6,'addr_method':'RR', 'datatype':'d', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':207, 'table':0, 'info':{'type':'xchg', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'bswap', 'dest':{'value':7,'addr_method':'RR', 'datatype':'d', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':208, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':209, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrlw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':210, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrld', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':211, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrlq', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':212, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'paddq', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':213, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pmullw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':214, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':215, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'pmovmskb', 'dest':{'value':0,'addr_method':'G', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':216, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psubusb', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':217, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psubusw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':218, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'pminub', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':219, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pand', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':220, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'paddusb', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':221, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'paddusw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':222, 'table':0, 'info':{'type':'unknown', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'pmaxub', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':223, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pandn', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':224, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'pavgb', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':225, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psraw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':226, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrad', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'pavgw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'pmulhuw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pmulhw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movntq', 'dest':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'V', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psubsb', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psubsw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'unknown', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'pminsw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'por', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'paddsb', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'paddsw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'unknown', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'pmaxsw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pxor', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psllw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':242, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pslld', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':243, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psllq', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pmuludq', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pmaddwd', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':246, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'psadbw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':247, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'maskmovq', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'pi', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psubb', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psubw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psubd', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psubq', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'paddb', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'paddw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':254, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'paddd', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_660F ___________________________
ia32_tbl_660F = (

{ 'byte':16, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movupd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movupd', 'dest':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movlpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'q', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movlpd', 'dest':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'V', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'unpcklpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'unpckhpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movhpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'q', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movhpd', 'dest':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':32, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':33, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':34, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':35, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':36, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':37, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':38, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':39, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':40, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movapd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':41, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movapd', 'dest':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':42, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtpi2pd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':43, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movntpd', 'dest':{'value':0,'addr_method':'M', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':44, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvttpd2pi', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':45, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtpd2pi', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':46, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'ucomisd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':47, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'comisd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':48, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':49, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':50, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':51, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':52, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':53, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':54, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':55, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':56, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':57, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':58, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':59, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':60, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':61, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':62, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':63, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':64, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':65, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':66, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':67, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':68, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':69, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':70, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':71, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':72, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':73, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':74, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':75, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':76, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':77, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':78, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':79, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':80, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movmskpd', 'dest':{'value':0,'addr_method':'G', 'datatype':'d', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':81, 'table':0, 'info':{'type':'fsqrt', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'sqrtpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':82, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':83, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':84, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'andpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':85, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'andnpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':86, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'orpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':87, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'xorpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':88, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'addpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':89, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'mulpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':90, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtpd2ps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':91, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtps2dq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':92, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'subpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':93, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'minpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':94, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'divpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':95, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'maxpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':96, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'punpcklbw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':97, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'punpcklwd', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':98, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'punpckldq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':99, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'packsswb', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':100, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pcmpgtb', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':101, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pcmpgtw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':102, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pcmpgtd', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':103, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'packuswb', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':104, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'punpckhbw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':105, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'punpckhwd', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':106, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'punpckhdq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':107, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'packssdw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':108, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'punpcklqdq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':109, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'punpckhqdq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':110, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movd', 'dest':{'value':0,'addr_method':'V', 'datatype':'d', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'E', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':111, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movdqa', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':112, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pshufd', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':113, 'table':15, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':114, 'table':17, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':115, 'table':19, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':116, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pcmpeqb', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':117, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pcmpeqw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':118, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pcmpeqd', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':119, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':120, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':121, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':122, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':123, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':124, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'haddpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':125, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'hsubpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':126, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movd', 'dest':{'value':0,'addr_method':'E', 'datatype':'d', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'V', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':127, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movdqa', 'dest':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':128, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':129, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':130, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':131, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':132, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':133, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':134, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':135, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':136, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':137, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':138, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':139, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':140, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':141, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':142, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':143, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':144, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':145, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':146, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':147, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':148, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':149, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':150, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':151, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':152, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':153, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':154, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':155, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':156, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':157, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':158, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':159, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':160, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':161, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':162, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':163, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':164, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':165, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':166, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':167, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':168, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':169, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':170, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':171, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':172, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':173, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':174, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':175, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':176, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':177, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':178, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':179, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':180, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':181, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':182, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':183, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':184, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':185, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':186, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':187, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':188, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':189, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':190, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':191, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':192, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':193, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':194, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cmppd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':195, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':196, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pinsrw', 'dest':{'value':0,'addr_method':'V', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':197, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pextrw', 'dest':{'value':0,'addr_method':'G', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'w', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':198, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'shufpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':199, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':200, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':201, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':202, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':203, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':204, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':205, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':206, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':207, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':208, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'addsubpd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':209, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psrlw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':210, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psrld', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':211, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psrlq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':212, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'paddq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':213, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pmullw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':214, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movq', 'dest':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'V', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':215, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pmovmskb', 'dest':{'value':0,'addr_method':'G', 'datatype':'d', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':216, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psubusb', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':217, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psubusw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':218, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pminub', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':219, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pand', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':220, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'paddusb', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':221, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'paddusw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':222, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pmaxub', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':223, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pandn', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':224, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pavgb', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':225, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psraw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':226, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psrad', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pavgw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pmulhuw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pmulhw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvttpd2dq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movntdq', 'dest':{'value':0,'addr_method':'M', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psubsb', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psubsw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pminsw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'por', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'paddsb', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'paddsw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pmaxsw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pxor', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psllw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':242, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pslld', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':243, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psllq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pmuludq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pmaddwd', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':246, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psadbw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':247, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'maskmovdqu', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psubb', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psubw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psubd', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'psubq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'paddb', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'paddw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':254, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'paddd', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_F20F ___________________________
ia32_tbl_F20F = (

{ 'byte':16, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movsd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movsd', 'dest':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movddup', 'dest':{'value':0,'addr_method':'V', 'datatype':'q', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':32, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':33, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':34, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':35, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':36, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':37, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':38, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':39, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':40, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':41, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':42, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtsi2sd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'E', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':43, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':44, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvttsd2si', 'dest':{'value':0,'addr_method':'G', 'datatype':'d', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':45, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtsd2si', 'dest':{'value':0,'addr_method':'G', 'datatype':'d', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':46, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':47, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':48, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':49, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':50, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':51, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':52, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':53, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':54, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':55, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':56, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':57, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':58, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':59, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':60, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':61, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':62, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':63, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':64, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':65, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':66, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':67, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':68, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':69, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':70, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':71, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':72, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':73, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':74, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':75, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':76, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':77, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':78, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':79, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':80, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':81, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'sqrtsd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':82, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':83, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':84, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':85, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':86, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':87, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':88, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'addsd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':89, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'mulsd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':90, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtsd2ss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':91, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':92, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'subsd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':93, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'minsd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':94, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'divsd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':95, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'maxsd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':96, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':97, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':98, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':99, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':100, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':101, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':102, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':103, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':104, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':105, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':106, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':107, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':108, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':109, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':110, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':111, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':112, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pshuflw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':113, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':114, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':115, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':116, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':117, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':118, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':119, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':120, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':121, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':122, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':123, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':124, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'haddps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':125, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'hsubps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':126, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':127, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':128, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':129, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':130, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':131, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':132, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':133, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':134, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':135, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':136, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':137, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':138, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':139, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':140, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':141, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':142, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':143, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':144, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':145, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':146, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':147, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':148, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':149, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':150, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':151, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':152, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':153, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':154, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':155, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':156, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':157, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':158, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':159, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':160, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':161, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':162, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':163, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':164, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':165, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':166, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':167, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':168, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':169, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':170, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':171, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':172, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':173, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':174, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':175, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':176, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':177, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':178, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':179, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':180, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':181, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':182, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':183, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':184, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':185, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':186, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':187, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':188, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':189, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':190, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':191, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':192, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':193, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':194, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cmpsd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':195, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':196, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':197, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':198, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':199, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':200, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':201, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':202, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':203, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':204, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':205, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':206, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':207, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':208, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'addsubps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':209, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':210, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':211, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':212, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':213, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':214, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movdq2q', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':215, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':216, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':217, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':218, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':219, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':220, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':221, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':222, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':223, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':224, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':225, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':226, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtpd2dq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'lddqu', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'M', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':242, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':243, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':246, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':247, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':254, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_F30F ___________________________
ia32_tbl_F30F = (

{ 'byte':16, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movss', 'dest':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movsldup', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movshdup', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':32, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':33, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':34, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':35, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':36, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':37, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':38, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':39, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':40, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':41, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':42, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtsi2ss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'E', 'datatype':'d', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':43, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':44, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvttss2si', 'dest':{'value':0,'addr_method':'G', 'datatype':'d', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':45, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtss2si', 'dest':{'value':0,'addr_method':'G', 'datatype':'d', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':46, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':47, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':48, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':49, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':50, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':51, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':52, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':53, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':54, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':55, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':56, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':57, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':58, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':59, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':60, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':61, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':62, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':63, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':64, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':65, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':66, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':67, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':68, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':69, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':70, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':71, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':72, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':73, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':74, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':75, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':76, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':77, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':78, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':79, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':80, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':81, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'sqrtss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':82, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'rsqrtss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':83, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'rcpss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':84, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':85, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':86, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':87, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':88, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'addss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':89, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'mulss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':90, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtss2sd', 'dest':{'value':0,'addr_method':'V', 'datatype':'sd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':91, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvttps2dq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':92, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'subss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':93, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'minss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':94, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'divss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':95, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'maxss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':96, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':97, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':98, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':99, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':100, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':101, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':102, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':103, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':104, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':105, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':106, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':107, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':108, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':109, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':110, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':111, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movdqu', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':112, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'pshufhw', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':113, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':114, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':115, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':116, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':117, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':118, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':119, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':120, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':121, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':122, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':123, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':124, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':125, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':126, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movq', 'dest':{'value':0,'addr_method':'V', 'datatype':'q', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':127, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movdqu', 'dest':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':128, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':129, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':130, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':131, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':132, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':133, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':134, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':135, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':136, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':137, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':138, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':139, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':140, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':141, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':142, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':143, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':144, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':145, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':146, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':147, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':148, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':149, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':150, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':151, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':152, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':153, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':154, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':155, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':156, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':157, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':158, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':159, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':160, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':161, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':162, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':163, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':164, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':165, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':166, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':167, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':168, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':169, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':170, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':171, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':172, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':173, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':174, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':175, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':176, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':177, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':178, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':179, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':180, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':181, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':182, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':183, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':184, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':185, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':186, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':187, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':188, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':189, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':190, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':191, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':192, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':193, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':194, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cmpss', 'dest':{'value':0,'addr_method':'V', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ss', 'signed':False, 'access':'r--'}, 'imm':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':195, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':196, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':197, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':198, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':199, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':200, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':201, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':202, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':203, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':204, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':205, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':206, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':207, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':208, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':209, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':210, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':211, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':212, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':213, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':214, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movq2dq', 'dest':{'value':0,'addr_method':'V', 'datatype':'dq', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':215, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':216, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':217, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':218, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':219, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':220, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':221, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':222, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':223, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':224, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':225, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':226, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'cvtdq2pd', 'dest':{'value':0,'addr_method':'V', 'datatype':'pd', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':242, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':243, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':246, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':247, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':254, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0F00 ___________________________
ia32_tbl_0F00 = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sldt', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':46, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'str', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':49, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lldt', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':29, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'ltr', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':32, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'verr', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'zero', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'verw', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'zero', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0F01 ___________________________
ia32_tbl_0F01 = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sgdt', 'dest':{'value':0,'addr_method':'M', 'datatype':'s', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':44, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sidt', 'dest':{'value':0,'addr_method':'M', 'datatype':'s', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':45, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lgdt', 'dest':{'value':0,'addr_method':'M', 'datatype':'s', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':27, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lidt', 'dest':{'value':0,'addr_method':'M', 'datatype':'s', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':28, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'smsw', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':47, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lmsw', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':30, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'invlpg', 'dest':{'value':0,'addr_method':'M', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sgdt', 'dest':{'value':0,'addr_method':'M', 'datatype':'s', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':44, 'eflags':{'set':'', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sidt', 'dest':{'value':0,'addr_method':'M', 'datatype':'s', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':45, 'eflags':{'set':'', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lgdt', 'dest':{'value':0,'addr_method':'M', 'datatype':'s', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':27, 'eflags':{'set':'', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lidt', 'dest':{'value':0,'addr_method':'M', 'datatype':'s', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':28, 'eflags':{'set':'', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'smsw', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':47, 'eflags':{'set':'', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lmsw', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':30, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'invlpg', 'dest':{'value':0,'addr_method':'M', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sgdt', 'dest':{'value':0,'addr_method':'M', 'datatype':'s', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':44, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sidt', 'dest':{'value':0,'addr_method':'M', 'datatype':'s', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':45, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lgdt', 'dest':{'value':0,'addr_method':'M', 'datatype':'s', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':27, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lidt', 'dest':{'value':0,'addr_method':'M', 'datatype':'s', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':28, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'smsw', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':47, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lmsw', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':30, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80486', 'isa':'general'}, 'mnemonic':'invlpg', 'dest':{'value':0,'addr_method':'M', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':10, 'info':{'type':'subtable', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'smsw', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':47, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'lmsw', 'dest':{'value':0,'addr_method':'E', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':30, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0F0111 ___________________________
ia32_tbl_0F0111 = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'monitor', 'dest':None, 'src':None, 'imm':None, 'implicit':54, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'mwait', 'dest':None, 'src':None, 'imm':None, 'implicit':55, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0F12 ___________________________
ia32_tbl_0F12 = (

{ 'byte':0, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movlps', 'dest':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movlps', 'dest':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movlps', 'dest':{'value':0,'addr_method':'W', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movhlps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0F16 ___________________________
ia32_tbl_0F16 = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movhps', 'dest':{'value':0,'addr_method':'V', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movhps', 'dest':{'value':0,'addr_method':'V', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'movhps', 'dest':{'value':0,'addr_method':'V', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'movlhps', 'dest':{'value':0,'addr_method':'V', 'datatype':'ps', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'W', 'datatype':'ps', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0F18 ___________________________
ia32_tbl_0F18 = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'prefetchnta', 'dest':{'value':0,'addr_method':'M', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'prefetcht0', 'dest':{'value':0,'addr_method':'RT', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'prefetcht1', 'dest':{'value':1,'addr_method':'RT', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'prefetcht2', 'dest':{'value':2,'addr_method':'RT', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'prefetchnta', 'dest':{'value':0,'addr_method':'M', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'prefetcht0', 'dest':{'value':0,'addr_method':'RT', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'prefetcht1', 'dest':{'value':1,'addr_method':'RT', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'prefetcht2', 'dest':{'value':2,'addr_method':'RT', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'prefetchnta', 'dest':{'value':0,'addr_method':'M', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'prefetcht0', 'dest':{'value':0,'addr_method':'RT', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'prefetcht1', 'dest':{'value':1,'addr_method':'RT', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'prefetcht2', 'dest':{'value':2,'addr_method':'RT', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0F71 ___________________________
ia32_tbl_0F71 = (

{ 'byte':0, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrlw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psraw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psllw', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_660F71 ___________________________
ia32_tbl_660F71 = (

{ 'byte':0, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrlw', 'dest':{'value':0,'addr_method':'P', 'datatype':'dq', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psraw', 'dest':{'value':0,'addr_method':'P', 'datatype':'dq', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psllw', 'dest':{'value':0,'addr_method':'P', 'datatype':'dq', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0F72 ___________________________
ia32_tbl_0F72 = (

{ 'byte':0, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrld', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrad', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pslld', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_660F72 ___________________________
ia32_tbl_660F72 = (

{ 'byte':0, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrld', 'dest':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrad', 'dest':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pslld', 'dest':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0F73 ___________________________
ia32_tbl_0F73 = (

{ 'byte':0, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrlq', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psllq', 'dest':{'value':0,'addr_method':'P', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_660F73 ___________________________
ia32_tbl_660F73 = (

{ 'byte':0, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrlq', 'dest':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psrldq', 'dest':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'psllq', 'dest':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'unknown', 'group':'other', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'pslldq', 'dest':{'value':0,'addr_method':'W', 'datatype':'dq', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0FAE ___________________________
ia32_tbl_0FAE = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'fxsave', 'dest':{'value':0,'addr_method':'E', 'datatype':'fx', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'fxrstor', 'dest':{'value':0,'addr_method':'E', 'datatype':'fx', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'ldmxcsr', 'dest':{'value':0,'addr_method':'E', 'datatype':'d', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':25, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'stmxcsr', 'dest':{'value':0,'addr_method':'E', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':48, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'clflush', 'dest':{'value':0,'addr_method':'M', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'fxsave', 'dest':{'value':0,'addr_method':'E', 'datatype':'fx', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'fxrstor', 'dest':{'value':0,'addr_method':'E', 'datatype':'fx', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'ldmxcsr', 'dest':{'value':0,'addr_method':'E', 'datatype':'d', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':25, 'eflags':{'set':'', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'stmxcsr', 'dest':{'value':0,'addr_method':'E', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':48, 'eflags':{'set':'', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'clflush', 'dest':{'value':0,'addr_method':'M', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'fxsave', 'dest':{'value':0,'addr_method':'E', 'datatype':'fx', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'mmx'}, 'mnemonic':'fxrstor', 'dest':{'value':0,'addr_method':'E', 'datatype':'fx', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'ldmxcsr', 'dest':{'value':0,'addr_method':'E', 'datatype':'d', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':25, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium2', 'isa':'general'}, 'mnemonic':'stmxcsr', 'dest':{'value':0,'addr_method':'E', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':48, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'clflush', 'dest':{'value':0,'addr_method':'M', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'lfence', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'mfence', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'sfence', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0FBA ___________________________
ia32_tbl_0FBA = (

{ 'byte':4, 'table':0, 'info':{'type':'bittest', 'group':'bit', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'bt', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'bittest', 'group':'bit', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'bts', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'bittest', 'group':'bit', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'btr', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'bittest', 'group':'bit', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'btc', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry', 'test':''} },
)


# TABLE ia32_tbl_0FC7 ___________________________
ia32_tbl_0FC7 = (

{ 'byte':0, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'xchgcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'general'}, 'mnemonic':'cmpxch8b', 'dest':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':9, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'xchgcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'general'}, 'mnemonic':'cmpxch8b', 'dest':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':9, 'eflags':{'set':'', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'xchgcc', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium', 'isa':'general'}, 'mnemonic':'cmpxch8b', 'dest':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':9, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0FB9 ___________________________
ia32_tbl_0FB9 = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'system', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'None', 'isa':'None'}, 'mnemonic':'fxsave', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_C6 ___________________________
ia32_tbl_C6 = (

{ 'byte':0, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_C7 ___________________________
ia32_tbl_C7 = (

{ 'byte':0, 'table':0, 'info':{'type':'mov', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mov', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_80 ___________________________
ia32_tbl_80 = (

{ 'byte':0, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'add', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'or', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'adc', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':3, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sbb', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':4, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'and', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sub', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xor', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmp', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },
)


# TABLE ia32_tbl_81 ___________________________
ia32_tbl_81 = (

{ 'byte':0, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'add', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'or', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'adc', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':3, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sbb', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':4, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'and', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sub', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xor', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmp', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },
)


# TABLE ia32_tbl_82 ___________________________
ia32_tbl_82 = (

{ 'byte':0, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'add', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'or', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'adc', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':3, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sbb', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':4, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'and', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sub', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xor', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmp', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },
)


# TABLE ia32_tbl_83 ___________________________
ia32_tbl_83 = (

{ 'byte':0, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'add', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'or', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'or', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'adc', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':3, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sbb', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':'carry'} },

{ 'byte':4, 'table':0, 'info':{'type':'and', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'and', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sub', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'xor', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'xor', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'cmp', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },
)


# TABLE ia32_tbl_C0 ___________________________
ia32_tbl_C0 = (

{ 'byte':0, 'table':0, 'info':{'type':'rol', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rol', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'ror', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'ror', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'rol', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rcl', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':'carry'} },

{ 'byte':3, 'table':0, 'info':{'type':'ror', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rcr', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':'carry'} },

{ 'byte':4, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shl', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shr', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sal', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sar', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },
)


# TABLE ia32_tbl_C1 ___________________________
ia32_tbl_C1 = (

{ 'byte':0, 'table':0, 'info':{'type':'rol', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rol', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'ror', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'ror', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'rol', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rcl', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':'carry'} },

{ 'byte':3, 'table':0, 'info':{'type':'ror', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rcr', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':'carry'} },

{ 'byte':4, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shl', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shr', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sal', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sar', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },
)


# TABLE ia32_tbl_D0 ___________________________
ia32_tbl_D0 = (

{ 'byte':0, 'table':0, 'info':{'type':'rol', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rol', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'ror', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'ror', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'rol', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rcl', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':'carry'} },

{ 'byte':3, 'table':0, 'info':{'type':'ror', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rcr', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':'carry'} },

{ 'byte':4, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shl', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shr', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sal', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sar', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },
)


# TABLE ia32_tbl_D1 ___________________________
ia32_tbl_D1 = (

{ 'byte':0, 'table':0, 'info':{'type':'rol', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rol', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'ror', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'ror', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'rol', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rcl', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':'carry'} },

{ 'byte':3, 'table':0, 'info':{'type':'ror', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rcr', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':'carry'} },

{ 'byte':4, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shl', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shr', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sal', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sar', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'II', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },
)


# TABLE ia32_tbl_D2 ___________________________
ia32_tbl_D2 = (

{ 'byte':0, 'table':0, 'info':{'type':'rol', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rol', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'ror', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'ror', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'rol', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rcl', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':'carry'} },

{ 'byte':3, 'table':0, 'info':{'type':'ror', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rcr', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':'carry'} },

{ 'byte':4, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shl', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shr', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sal', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sar', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },
)


# TABLE ia32_tbl_D3 ___________________________
ia32_tbl_D3 = (

{ 'byte':0, 'table':0, 'info':{'type':'rol', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rol', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'ror', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'ror', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'rol', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rcl', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':'carry'} },

{ 'byte':3, 'table':0, 'info':{'type':'ror', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'rcr', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry oflow', 'test':'carry'} },

{ 'byte':4, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shl', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'shr', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'shl', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sal', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'shr', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'sar', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':1,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },
)


# TABLE ia32_tbl_F6 ___________________________
ia32_tbl_F6 = (

{ 'byte':0, 'table':0, 'info':{'type':'test', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'test', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'test', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'test', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'not', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'not', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'neg', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'neg', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mul', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':22, 'eflags':{'set':'oflow carry', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'imul', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':22, 'eflags':{'set':'oflow carry', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'div', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'div', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':13, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'div', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'idiv', 'dest':{'value':0,'addr_method':'RR', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':13, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_F7 ___________________________
ia32_tbl_F7 = (

{ 'byte':0, 'table':0, 'info':{'type':'test', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'test', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'test', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'test', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':{'value':0,'addr_method':'I', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'not', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'not', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'neg', 'group':'logic', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'neg', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'carry zero overflow sign parity', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'mul', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':23, 'eflags':{'set':'oflow carry', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'imul', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':True, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':True, 'access':'r--'}, 'imm':None, 'implicit':23, 'eflags':{'set':'oflow carry', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'div', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'div', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':14, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'div', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'idiv', 'dest':{'value':0,'addr_method':'RR', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':14, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_FE ___________________________
ia32_tbl_FE = (

{ 'byte':0, 'table':0, 'info':{'type':'inc', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'inc', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'dec', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'dec', 'dest':{'value':0,'addr_method':'E', 'datatype':'b', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },
)


# TABLE ia32_tbl_FF ___________________________
ia32_tbl_FF = (

{ 'byte':0, 'table':0, 'info':{'type':'inc', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'inc', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'dec', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'dec', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'rw-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'oflow sign zero parity', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'call', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'call', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':3, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'call', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'callf', 'dest':{'value':0,'addr_method':'E', 'datatype':'p', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'branch', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jmp', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'branch', 'group':'exec', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'jmp', 'dest':{'value':0,'addr_method':'E', 'datatype':'p', 'signed':False, 'access':'--x'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'push', 'group':'stack', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80386', 'isa':'general'}, 'mnemonic':'push', 'dest':{'value':0,'addr_method':'E', 'datatype':'v', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':33, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_D8 ___________________________
ia32_tbl_D8 = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':0,'addr_method':'M', 'datatype':'fs', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':0,'addr_method':'M', 'datatype':'fs', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcom', 'dest':{'value':0,'addr_method':'M', 'datatype':'fs', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':17, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomp', 'dest':{'value':0,'addr_method':'M', 'datatype':'fs', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':0,'addr_method':'M', 'datatype':'fs', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':0,'addr_method':'M', 'datatype':'fs', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':0,'addr_method':'M', 'datatype':'fs', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':0,'addr_method':'M', 'datatype':'fs', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_D8C0 ___________________________
ia32_tbl_D8C0 = (

{ 'byte':192, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':193, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':194, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':195, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':196, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':197, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':198, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':199, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':200, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':201, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':202, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':203, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':204, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':205, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':206, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':207, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':208, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcom', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':17, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':209, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcom', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':17, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':210, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcom', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':17, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':211, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcom', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':17, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':212, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcom', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':17, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':213, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcom', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':17, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':214, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcom', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':17, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':215, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcom', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':17, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':216, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':217, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':218, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':219, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':220, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':221, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':222, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':223, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':224, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':225, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':226, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':242, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':243, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':246, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':247, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':254, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_D9 ___________________________
ia32_tbl_D9 = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fld', 'dest':{'value':0,'addr_method':'M', 'datatype':'fs', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fst', 'dest':{'value':0,'addr_method':'M', 'datatype':'fs', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fstp', 'dest':{'value':0,'addr_method':'M', 'datatype':'fs', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fldenv', 'dest':{'value':0,'addr_method':'M', 'datatype':'fv', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fldcw', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fnstenv', 'dest':{'value':0,'addr_method':'M', 'datatype':'fv', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fnstcw', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_D9C0 ___________________________
ia32_tbl_D9C0 = (

{ 'byte':192, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fld', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':193, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fld', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':194, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fld', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':195, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fld', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':196, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fld', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':197, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fld', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':198, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fld', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':199, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fld', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':200, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fxch', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':201, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fxch', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':202, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fxch', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':203, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fxch', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':204, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fxch', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':205, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fxch', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':206, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fxch', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':207, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fxch', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':208, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fnop', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':209, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':210, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':211, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':212, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':213, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':214, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':215, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':216, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':217, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':218, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':219, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':220, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':221, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':222, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':223, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':224, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fchs', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':225, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fabs', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':226, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ftst', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fxam', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fld1', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fldl2t', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fldl2e', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fldpi', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fldlg2', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fldln2', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fldz', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'f2xm1', 'dest':None, 'src':None, 'imm':None, 'implicit':16, 'eflags':{'set':'', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fyl2x', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':242, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fptan', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':243, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fpatan', 'dest':None, 'src':None, 'imm':None, 'implicit':18, 'eflags':{'set':'', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fxtract', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fprem1', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':246, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdecstp', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':247, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fincstp', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fprem', 'dest':None, 'src':None, 'imm':None, 'implicit':19, 'eflags':{'set':'', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fyl2xp1', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsqrt', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsincos', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'frndint', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fscale', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':254, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsin', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcos', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_DA ___________________________
ia32_tbl_DA = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fiadd', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fimul', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ficom', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ficomp', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fisub', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fisubr', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fidiv', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fidivr', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_DAC0 ___________________________
ia32_tbl_DAC0 = (

{ 'byte':192, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry'} },

{ 'byte':193, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry'} },

{ 'byte':194, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry'} },

{ 'byte':195, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry'} },

{ 'byte':196, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry'} },

{ 'byte':197, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry'} },

{ 'byte':198, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry'} },

{ 'byte':199, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry'} },

{ 'byte':200, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmove', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':201, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmove', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':202, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmove', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':203, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmove', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':204, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmove', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':205, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmove', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':206, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmove', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':207, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmove', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'zero'} },

{ 'byte':208, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry or zero'} },

{ 'byte':209, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry or zero'} },

{ 'byte':210, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry or zero'} },

{ 'byte':211, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry or zero'} },

{ 'byte':212, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry or zero'} },

{ 'byte':213, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry or zero'} },

{ 'byte':214, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry or zero'} },

{ 'byte':215, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'carry or zero'} },

{ 'byte':216, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'parity'} },

{ 'byte':217, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'parity'} },

{ 'byte':218, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'parity'} },

{ 'byte':219, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'parity'} },

{ 'byte':220, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'parity'} },

{ 'byte':221, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'parity'} },

{ 'byte':222, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'parity'} },

{ 'byte':223, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcmovu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'parity'} },

{ 'byte':224, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':225, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':226, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucompp', 'dest':None, 'src':None, 'imm':None, 'implicit':21, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':242, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':243, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':246, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':247, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':254, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_DB ___________________________
ia32_tbl_DB = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fild', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'fisttp', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fist', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fistp', 'dest':{'value':0,'addr_method':'M', 'datatype':'d', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fld', 'dest':{'value':0,'addr_method':'M', 'datatype':'fe', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fstp', 'dest':{'value':0,'addr_method':'M', 'datatype':'fe', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_DBC0 ___________________________
ia32_tbl_DBC0 = (

{ 'byte':192, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry'} },

{ 'byte':193, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry'} },

{ 'byte':194, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry'} },

{ 'byte':195, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry'} },

{ 'byte':196, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry'} },

{ 'byte':197, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry'} },

{ 'byte':198, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry'} },

{ 'byte':199, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnb', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry'} },

{ 'byte':200, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovne', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':201, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovne', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':202, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovne', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':203, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovne', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':204, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovne', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':205, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovne', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':206, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovne', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':207, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovne', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nzero'} },

{ 'byte':208, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry nzero'} },

{ 'byte':209, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry nzero'} },

{ 'byte':210, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry nzero'} },

{ 'byte':211, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry nzero'} },

{ 'byte':212, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry nzero'} },

{ 'byte':213, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry nzero'} },

{ 'byte':214, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry nzero'} },

{ 'byte':215, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnbe', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'ncarry nzero'} },

{ 'byte':216, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nparity'} },

{ 'byte':217, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nparity'} },

{ 'byte':218, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nparity'} },

{ 'byte':219, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nparity'} },

{ 'byte':220, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nparity'} },

{ 'byte':221, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nparity'} },

{ 'byte':222, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nparity'} },

{ 'byte':223, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcmovnu', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':'nparity'} },

{ 'byte':224, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':225, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':226, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fnclex', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fninit', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':242, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':243, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':246, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':247, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentpro', 'isa':'general'}, 'mnemonic':'fcomi', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':254, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_DC ___________________________
ia32_tbl_DC = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':0,'addr_method':'M', 'datatype':'fd', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':0,'addr_method':'M', 'datatype':'fd', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcom', 'dest':{'value':0,'addr_method':'M', 'datatype':'fd', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':17, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomp', 'dest':{'value':0,'addr_method':'M', 'datatype':'fd', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':0,'addr_method':'M', 'datatype':'fd', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':0,'addr_method':'M', 'datatype':'fd', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':0,'addr_method':'M', 'datatype':'fd', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':0,'addr_method':'M', 'datatype':'fd', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_DCC0 ___________________________
ia32_tbl_DCC0 = (

{ 'byte':192, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':193, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':194, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':195, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':196, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':197, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':198, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':199, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fadd', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':200, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':201, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':202, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':203, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':204, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':205, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':206, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':207, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmul', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':208, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':209, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':210, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':211, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':212, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':213, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':214, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':215, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':216, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':217, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':218, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':219, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':220, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':221, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':222, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':223, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':224, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':225, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':226, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubr', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsub', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':242, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':243, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':246, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':247, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivr', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':254, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdiv', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_DD ___________________________
ia32_tbl_DD = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fld', 'dest':{'value':0,'addr_method':'M', 'datatype':'fd', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'fisttp', 'dest':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fst', 'dest':{'value':0,'addr_method':'M', 'datatype':'fd', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fstp', 'dest':{'value':0,'addr_method':'M', 'datatype':'fd', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'frstor', 'dest':{'value':0,'addr_method':'M', 'datatype':'ft', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fnsave', 'dest':{'value':0,'addr_method':'M', 'datatype':'ft', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fnstsw', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_DDC0 ___________________________
ia32_tbl_DDC0 = (

{ 'byte':192, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ffree', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':193, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ffree', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':194, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ffree', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':195, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ffree', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':196, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ffree', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':197, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ffree', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':198, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ffree', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':199, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ffree', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':200, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':201, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':202, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':203, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':204, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':205, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':206, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':207, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':208, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fst', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':209, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fst', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':210, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fst', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':211, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fst', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':212, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fst', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':213, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fst', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':214, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fst', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':215, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fst', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':216, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fstp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':217, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fstp', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':218, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fstp', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':219, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fstp', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':220, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fstp', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':221, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fstp', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':222, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fstp', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':223, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fstp', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':224, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucom', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':225, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucom', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':226, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucom', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucom', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucom', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucom', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucom', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucom', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomp', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomp', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomp', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomp', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomp', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomp', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomp', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':242, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':243, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':246, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':247, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':254, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_DE ___________________________
ia32_tbl_DE = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fiadd', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fimul', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ficom', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'ficomp', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fisub', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fisubr', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fidiv', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fidivr', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_DEC0 ___________________________
ia32_tbl_DEC0 = (

{ 'byte':192, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'faddp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':20, 'eflags':{'set':'', 'test':''} },

{ 'byte':193, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'faddp', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':20, 'eflags':{'set':'', 'test':''} },

{ 'byte':194, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'faddp', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':20, 'eflags':{'set':'', 'test':''} },

{ 'byte':195, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'faddp', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':20, 'eflags':{'set':'', 'test':''} },

{ 'byte':196, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'faddp', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':20, 'eflags':{'set':'', 'test':''} },

{ 'byte':197, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'faddp', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':20, 'eflags':{'set':'', 'test':''} },

{ 'byte':198, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'faddp', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':20, 'eflags':{'set':'', 'test':''} },

{ 'byte':199, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'faddp', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':20, 'eflags':{'set':'', 'test':''} },

{ 'byte':200, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmulp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':201, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmulp', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':202, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmulp', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':203, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmulp', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':204, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmulp', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':205, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmulp', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':206, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmulp', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':207, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fmulp', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':208, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':209, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':210, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':211, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':212, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':213, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':214, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':215, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':216, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':217, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcompp', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':218, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':219, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':220, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':221, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':222, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':223, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':224, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubrp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':225, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubrp', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':226, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubrp', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubrp', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubrp', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubrp', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubrp', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubrp', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubp', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubp', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubp', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubp', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubp', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubp', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fsubp', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivrp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivrp', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':242, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivrp', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':243, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivrp', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivrp', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivrp', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':246, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivrp', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':247, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivrp', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivp', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivp', 'dest':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivp', 'dest':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivp', 'dest':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivp', 'dest':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivp', 'dest':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':254, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivp', 'dest':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fdivp', 'dest':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_DF ___________________________
ia32_tbl_DF = (

{ 'byte':0, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fild', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'pentium4', 'isa':'general'}, 'mnemonic':'fisttp', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fist', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fistp', 'dest':{'value':0,'addr_method':'M', 'datatype':'w', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fbld', 'dest':{'value':0,'addr_method':'M', 'datatype':'fb', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fild', 'dest':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fbstp', 'dest':{'value':0,'addr_method':'M', 'datatype':'fb', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fistp', 'dest':{'value':0,'addr_method':'M', 'datatype':'q', 'signed':False, 'access':'-w-'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_DFC0 ___________________________
ia32_tbl_DFC0 = (

{ 'byte':192, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':193, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':194, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':195, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':196, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':197, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':198, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':199, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':200, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':201, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':202, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':203, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':204, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':205, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':206, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':207, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':208, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':209, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':210, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':211, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':212, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':213, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':214, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':215, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':216, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':217, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':218, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':219, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':220, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':221, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':222, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':223, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':224, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fnstsw', 'dest':{'value':0,'addr_method':'RR', 'datatype':'w', 'signed':False, 'access':'r--'}, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':225, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':226, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':227, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':228, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':229, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':230, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':231, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':232, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':233, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':234, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':235, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':236, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':237, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':238, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':239, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fucomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':240, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':241, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':1,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':242, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':2,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':243, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':3,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':244, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':4,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':245, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':5,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':246, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':6,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':247, 'table':0, 'info':{'type':'unknown', 'group':'fpu', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'fcomip', 'dest':{'value':0,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'-w-'}, 'src':{'value':7,'addr_method':'RF', 'datatype':'fp', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'zero parity carry', 'test':''} },

{ 'byte':248, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':249, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':250, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':251, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':252, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':253, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':254, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':255, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'80387', 'isa':'fpu'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


# TABLE ia32_tbl_0F0F ___________________________
ia32_tbl_0F0F = (

{ 'byte':0, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':1, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':2, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':3, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':4, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':5, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':6, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':7, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':8, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':9, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':10, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':11, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':12, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':13, 'table':0, 'info':{'type':'conv', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pi2fd', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':14, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':15, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':16, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':17, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':18, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':19, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':20, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':21, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':22, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':23, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':24, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':25, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':26, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':27, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':28, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':29, 'table':0, 'info':{'type':'conv', 'group':'load', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pf2id', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':30, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':31, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':32, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':33, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':34, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':35, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':36, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':37, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':38, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':39, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':40, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':41, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':42, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':43, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':44, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':45, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':46, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':47, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':48, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':49, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':50, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':51, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':52, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':53, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':54, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':55, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':56, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':57, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':58, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':59, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':60, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':61, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':62, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':63, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':64, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':65, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':66, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':67, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':68, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':69, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':70, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':71, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':72, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':73, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':74, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':75, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':76, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':77, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':78, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':79, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':80, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':81, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':82, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':83, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':84, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':85, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':86, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':87, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':88, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':89, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':90, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':91, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':92, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':93, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':94, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':95, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':96, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':97, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':98, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':99, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':100, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':101, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':102, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':103, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':104, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':105, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':106, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':107, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':108, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':109, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':110, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':111, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':112, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':113, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':114, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':115, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':116, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':117, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':118, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':119, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':120, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':121, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':122, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':123, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':124, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':125, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':126, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':127, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':128, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':129, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':130, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':131, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':132, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':133, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':134, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':135, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':136, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':137, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':138, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':139, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':140, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':141, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':142, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':143, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':144, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfcmpge', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':145, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':146, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':147, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':148, 'table':0, 'info':{'type':'min', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfmin', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':149, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':150, 'table':0, 'info':{'type':'unknown', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfrcp', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':151, 'table':0, 'info':{'type':'unknown', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfrsqrt', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':152, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':153, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':154, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfsub', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':155, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':156, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':157, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':158, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfadd', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':159, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':160, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfcmpgt', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':161, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':162, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':163, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':164, 'table':0, 'info':{'type':'max', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfmax', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':165, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':166, 'table':0, 'info':{'type':'unknown', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfrcpit1', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':167, 'table':0, 'info':{'type':'unknown', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfrsqit1', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':168, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':169, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':170, 'table':0, 'info':{'type':'sub', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfsubr', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':171, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':172, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':173, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':174, 'table':0, 'info':{'type':'add', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfacc', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':175, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':176, 'table':0, 'info':{'type':'cmp', 'group':'cond', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfcmpeq', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':177, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':178, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':179, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':180, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfmul', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':181, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':182, 'table':0, 'info':{'type':'unknown', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pfrcpit2', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':183, 'table':0, 'info':{'type':'mul', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pmulhrw', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':184, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':185, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':186, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':187, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':188, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':189, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':190, 'table':0, 'info':{'type':'invalid', 'group':'invalid', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'', 'dest':None, 'src':None, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },

{ 'byte':191, 'table':0, 'info':{'type':'avg', 'group':'arith', 'prefix':False, 'suffix':False, 'ring0':False, 'smm':False, 'serializing':False, 'cpu':'k6', 'isa':'3dnow'}, 'mnemonic':'pavgusb', 'dest':{'value':0,'addr_method':'P', 'datatype':'pi', 'signed':False, 'access':'rw-'}, 'src':{'value':0,'addr_method':'Q', 'datatype':'q', 'signed':False, 'access':'r--'}, 'imm':None, 'implicit':None, 'eflags':{'set':'', 'test':''} },
)


#______________________________________________________________
# Table of opcode tables: 
ia32_tables = (
	{ 'index':0, 'table':ia32_tbl_Main, 'name':'ia32_tbl_Main', 'type':'opcode', 'shift':0x00, 'mask':0xFF, 'min':0x00, 'max':0xFF },
	{ 'index':1, 'table':ia32_tbl_66, 'name':'ia32_tbl_66', 'type':'prefix', 'shift':0x00, 'mask':0xFF, 'min':0x0F, 'max':0x0F },
	{ 'index':2, 'table':ia32_tbl_F2, 'name':'ia32_tbl_F2', 'type':'prefix', 'shift':0x00, 'mask':0xFF, 'min':0x0F, 'max':0x0F },
	{ 'index':3, 'table':ia32_tbl_F3, 'name':'ia32_tbl_F3', 'type':'prefix', 'shift':0x00, 'mask':0xFF, 'min':0x0F, 'max':0x90 },
	{ 'index':4, 'table':ia32_tbl_0F, 'name':'ia32_tbl_0F', 'type':'opcode', 'shift':0x00, 'mask':0xFF, 'min':0x00, 'max':0xFF },
	{ 'index':5, 'table':ia32_tbl_660F, 'name':'ia32_tbl_660F', 'type':'prefix', 'shift':0x00, 'mask':0xFF, 'min':0x10, 'max':0xFF },
	{ 'index':6, 'table':ia32_tbl_F20F, 'name':'ia32_tbl_F20F', 'type':'prefix', 'shift':0x00, 'mask':0xFF, 'min':0x10, 'max':0xFF },
	{ 'index':7, 'table':ia32_tbl_F30F, 'name':'ia32_tbl_F30F', 'type':'prefix', 'shift':0x00, 'mask':0xFF, 'min':0x10, 'max':0xFF },
	{ 'index':8, 'table':ia32_tbl_0F00, 'name':'ia32_tbl_0F00', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':9, 'table':ia32_tbl_0F01, 'name':'ia32_tbl_0F01', 'type':'extension', 'shift':0x03, 'mask':0x1F, 'min':0x00, 'max':0x1F },
	{ 'index':10, 'table':ia32_tbl_0F0111, 'name':'ia32_tbl_0F0111', 'type':'ext_ext', 'shift':0x00, 'mask':0x01, 'min':0x00, 'max':0x01 },
	{ 'index':11, 'table':ia32_tbl_0F12, 'name':'ia32_tbl_0F12', 'type':'extension', 'shift':0x06, 'mask':0x03, 'min':0x00, 'max':0x03 },
	{ 'index':12, 'table':ia32_tbl_0F16, 'name':'ia32_tbl_0F16', 'type':'extension', 'shift':0x06, 'mask':0x03, 'min':0x00, 'max':0x03 },
	{ 'index':13, 'table':ia32_tbl_0F18, 'name':'ia32_tbl_0F18', 'type':'extension', 'shift':0x03, 'mask':0x1F, 'min':0x00, 'max':0x13 },
	{ 'index':14, 'table':ia32_tbl_0F71, 'name':'ia32_tbl_0F71', 'type':'extension', 'shift':0x03, 'mask':0x1F, 'min':0x00, 'max':0x1F },
	{ 'index':15, 'table':ia32_tbl_660F71, 'name':'ia32_tbl_660F71', 'type':'extension', 'shift':0x03, 'mask':0x1F, 'min':0x00, 'max':0x1F },
	{ 'index':16, 'table':ia32_tbl_0F72, 'name':'ia32_tbl_0F72', 'type':'extension', 'shift':0x03, 'mask':0x1F, 'min':0x00, 'max':0x1F },
	{ 'index':17, 'table':ia32_tbl_660F72, 'name':'ia32_tbl_660F72', 'type':'extension', 'shift':0x03, 'mask':0x1F, 'min':0x00, 'max':0x1F },
	{ 'index':18, 'table':ia32_tbl_0F73, 'name':'ia32_tbl_0F73', 'type':'extension', 'shift':0x00, 'mask':0x00, 'min':0x00, 'max':0x00 },
	{ 'index':19, 'table':ia32_tbl_660F73, 'name':'ia32_tbl_660F73', 'type':'extension', 'shift':0x03, 'mask':0x1F, 'min':0x00, 'max':0x1F },
	{ 'index':20, 'table':ia32_tbl_0FAE, 'name':'ia32_tbl_0FAE', 'type':'extension', 'shift':0x03, 'mask':0x1F, 'min':0x00, 'max':0x1F },
	{ 'index':21, 'table':ia32_tbl_0FBA, 'name':'ia32_tbl_0FBA', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x04, 'max':0x07 },
	{ 'index':22, 'table':ia32_tbl_0FC7, 'name':'ia32_tbl_0FC7', 'type':'extension', 'shift':0x03, 'mask':0x1F, 'min':0x00, 'max':0x11 },
	{ 'index':23, 'table':ia32_tbl_0FB9, 'name':'ia32_tbl_0FB9', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x00 },
	{ 'index':24, 'table':ia32_tbl_C6, 'name':'ia32_tbl_C6', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x00 },
	{ 'index':25, 'table':ia32_tbl_C7, 'name':'ia32_tbl_C7', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x00 },
	{ 'index':26, 'table':ia32_tbl_80, 'name':'ia32_tbl_80', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':27, 'table':ia32_tbl_81, 'name':'ia32_tbl_81', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':28, 'table':ia32_tbl_82, 'name':'ia32_tbl_82', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':29, 'table':ia32_tbl_83, 'name':'ia32_tbl_83', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':30, 'table':ia32_tbl_C0, 'name':'ia32_tbl_C0', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':31, 'table':ia32_tbl_C1, 'name':'ia32_tbl_C1', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':32, 'table':ia32_tbl_D0, 'name':'ia32_tbl_D0', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':33, 'table':ia32_tbl_D1, 'name':'ia32_tbl_D1', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':34, 'table':ia32_tbl_D2, 'name':'ia32_tbl_D2', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':35, 'table':ia32_tbl_D3, 'name':'ia32_tbl_D3', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':36, 'table':ia32_tbl_F6, 'name':'ia32_tbl_F6', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':37, 'table':ia32_tbl_F7, 'name':'ia32_tbl_F7', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x07 },
	{ 'index':38, 'table':ia32_tbl_FE, 'name':'ia32_tbl_FE', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x01 },
	{ 'index':39, 'table':ia32_tbl_FF, 'name':'ia32_tbl_FF', 'type':'extension', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0x06 },
	{ 'index':40, 'table':ia32_tbl_D8, 'name':'ia32_tbl_D8', 'type':'fpu', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0xBF },
	{ 'index':41, 'table':ia32_tbl_D8C0, 'name':'ia32_tbl_D8C0', 'type':'fpu_ext', 'shift':0x00, 'mask':0xFF, 'min':0xC0, 'max':0xFF },
	{ 'index':42, 'table':ia32_tbl_D9, 'name':'ia32_tbl_D9', 'type':'fpu', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0xBF },
	{ 'index':43, 'table':ia32_tbl_D9C0, 'name':'ia32_tbl_D9C0', 'type':'fpu_ext', 'shift':0x00, 'mask':0xFF, 'min':0xC0, 'max':0xFF },
	{ 'index':44, 'table':ia32_tbl_DA, 'name':'ia32_tbl_DA', 'type':'fpu', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0xBF },
	{ 'index':45, 'table':ia32_tbl_DAC0, 'name':'ia32_tbl_DAC0', 'type':'fpu_ext', 'shift':0x00, 'mask':0xFF, 'min':0xC0, 'max':0xFF },
	{ 'index':46, 'table':ia32_tbl_DB, 'name':'ia32_tbl_DB', 'type':'fpu', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0xBF },
	{ 'index':47, 'table':ia32_tbl_DBC0, 'name':'ia32_tbl_DBC0', 'type':'fpu_ext', 'shift':0x00, 'mask':0xFF, 'min':0xC0, 'max':0xFF },
	{ 'index':48, 'table':ia32_tbl_DC, 'name':'ia32_tbl_DC', 'type':'fpu', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0xBF },
	{ 'index':49, 'table':ia32_tbl_DCC0, 'name':'ia32_tbl_DCC0', 'type':'fpu_ext', 'shift':0x00, 'mask':0xFF, 'min':0xC0, 'max':0xFF },
	{ 'index':50, 'table':ia32_tbl_DD, 'name':'ia32_tbl_DD', 'type':'fpu', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0xBF },
	{ 'index':51, 'table':ia32_tbl_DDC0, 'name':'ia32_tbl_DDC0', 'type':'fpu_ext', 'shift':0x00, 'mask':0xFF, 'min':0xC0, 'max':0xFF },
	{ 'index':52, 'table':ia32_tbl_DE, 'name':'ia32_tbl_DE', 'type':'fpu', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0xBF },
	{ 'index':53, 'table':ia32_tbl_DEC0, 'name':'ia32_tbl_DEC0', 'type':'fpu_ext', 'shift':0x00, 'mask':0xFF, 'min':0xC0, 'max':0xFF },
	{ 'index':54, 'table':ia32_tbl_DF, 'name':'ia32_tbl_DF', 'type':'fpu', 'shift':0x03, 'mask':0x07, 'min':0x00, 'max':0xBF },
	{ 'index':55, 'table':ia32_tbl_DFC0, 'name':'ia32_tbl_DFC0', 'type':'fpu_ext', 'shift':0x00, 'mask':0xFF, 'min':0xC0, 'max':0xFF },
	{ 'index':56, 'table':ia32_tbl_0F0F, 'name':'ia32_tbl_0F0F', 'type':'suffix', 'shift':0x00, 'mask':0xFF, 'min':0x00, 'max':0xBF }
)

